#!usr/bin/wish

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#                                                                               #
#  sfrm - software for requirement management v. 1.0.0                          #
#                                                                               #
#  Idea: Jorma Sajaniemi                                                        #
#  Toteutus: Jussi Khknen                                                     #
#  Copyright: Joensuun yliopisto, tietojenksittelytieteen laitos 2001 - 2002   #
#                                                                               #
#  Tst jakeluversiosta on poistettu lhdekoodin kommentit.                    #
#                                                                               #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


proc asetaNollaArvot {idTunnus pa} {
	
	global idTun v tietoLkm

	set idTun $idTunnus
	set v($idTun,id) $idTun 
	set v($idTun,nimi) ""
	set v($idTun,paikka) $pa
	set v($idTun,solmu) ""
	set v($idTun,kuvaus) ""
	set v($idTun,yhteydet) {}
	for {set i 0} {$i < $tietoLkm} {incr i 1} {
		set v($idTun,$i) ""
	}
}

proc avaaEditoriin {i} {
	global idTun k m 

	set editori $m(editori)
	if {$i == "yleistiedot"} {
		set ikkuna .yleisetIkkuna.f.txt
	} else {
		set ikkuna .vaatimus-$idTun.frKanvaasi.ca.frPo.fr$i.te$i
	}
	set teksti [$ikkuna get 1.0 end] 
	set tiedosto "$idTun-$i.tmp"

	if {$editori == ""} {
			set otsikko $k(lataaoletukset) 
			set huomautus $k(oletuseditoriaeiole)
			tk_dialog .dialog_ra $otsikko $huomautus info 0 OK
	} else {
	    	set t [open $tiedosto "w+"]
		puts $t $teksti 
		close $t
		if {[catch {exec $editori $tiedosto} errmsg]} {
			set otsikko $k(avaaeditoriin) 
			set huomautus "$k(virheavattaessaeditoria) $errmsg"
			tk_dialog .dialog_avm1 $otsikko $huomautus info 0 OK
		} else {
			$ikkuna delete 1.0 end
		    	set t [open $tiedosto "r"]
	    		while {! [eof $t]} {
				gets $t rivi
				$ikkuna insert end $rivi\n
			}
			close $t
		}
		file delete -force $tiedosto
	}
}

proc avaaTaiLisaaVaatimus {paikka nimi} {
	
	set onOtsikko [onkoOtsikko $nimi]
	set onAlinOtsikko [onkoAlinOtsikko .list $paikka] 
	if {$onOtsikko && $onAlinOtsikko} {
		lisaaVaatimus $paikka
	} elseif {! $onOtsikko} {
		avaaVaatimusikkuna [haeIdTunnusPaikka $paikka]
	}
}

proc avaaVaatimusikkuna {idTunnus} {
   	global c idTun k v vi
	global tietoLkm rbValinta tallennettu 

	set idTun $idTunnus
	set vi .vaatimus-$idTun
   	if {[winfo exists $vi]} {
     		wm deiconify $vi
     		raise $vi
	  	focus $vi
	} else {
		set pa $v($idTun,paikka) 
		luoVaatimusikkuna $pa 1 
		set f $vi.frKanvaasi.ca.frPo
	 	$f.frId.enId configure -state normal 
		$f.frId.enId delete 0 end  		 
		sijoitaTietoKenttaan $idTun "$f.frId.enId" "$v($idTun,id)"  
		sijoitaTietoKenttaan $idTun "$f.frNi.enNi" "$v($idTun,nimi)"
		sijoitaTietoKenttaan $idTun "$f.frKu.teKu" "$v($idTun,kuvaus)"
		paivitaVaatimuksenYhteydet $idTun 
		for {set i 0} {$i < $tietoLkm} {incr i 1} {
			switch $c($i,tyyppi) {		
				<tekstiL>  	{
						sijoitaTietoKenttaan $idTun "$f.fr$i.en$i" "$v($idTun,$i)"
						set tallennettu($vi) 1
						set tallennettu(tiedostoon) 1
						}  	
				<tekstiP>  	{sijoitaTietoKenttaan $idTun "$f.fr$i.te$i" "$v($idTun,$i)"} 	
				<luokitus> 	{
						if {$v($idTun,$i) != ""} {
							set y "$v($idTun,$i)" 
							set x [string range $y 5 [expr [string length $y] - 1]]
							$f.fr$i.frRb$i.rbu$x select 
						} 
						}	
 			}
		}
	 	$f.frId.enId configure -state disabled 
		$vi.fb.poista configure -state normal  
     		raise $vi
	  	focus $vi
		set tallennettu($vi) 1          
		set tallennettu(tiedostoon) 1   
  	}
	laajennaSolmu "$v($idTun,solmu)" "root" 
}

proc haeIdTunnusNimi {nimi} {
	global v vaatimukset

	foreach i $vaatimukset {
		if {[string compare "$nimi" $v($i,nimi)] == 0} {
			set tunnus $v($i,id) 
			break
		}
	}
	return $tunnus
}

proc jarjestaVaatimukset {} {
	global vaatimukset
	set apu $vaatimukset 
	set vaatimukset [lsort -dictionary $apu]
}

proc lisaaVaatimus {paikka} {
	global idTun alasolmut k m uudet v vaatimukset 

      set alku $m(alkunumero)
      set loppu $m(loppunumero)
	set idTun ""
  	if {$loppu > -1} {
		if {[llength $vaatimukset] == 0} { 
	      	set idTun "id$alku" 
		} else {
			set next $alku  
			foreach i $vaatimukset {
				set x [string range $i 2 end] 
				if {$x < $next} {
					continue
				} elseif {$x == $next && $next <= $loppu} {
					incr next
					continue
				} elseif {$next <= $loppu} {	
					set idTun "id$next"
					break
				} 
			}
			if {$idTun == "" && $next <= $loppu} {
				set idTun "id$next"
			} elseif {$idTun == "" && $next > $loppu} {
				set otsikko $k(vaatimuksenlisaaminen)
				set huomautus $k(numerotloppui)
				tk_dialog .dialog_lv $otsikko $huomautus info 0 OK
			}
		}
		if {$idTun != ""} { 
			lappend vaatimukset $idTun 
			jarjestaVaatimukset
			lappend uudet $idTun
			lappend alasolmut($paikka) $idTun
			set v($idTun,jnro) [llength $alasolmut($paikka)]
			asetaNollaArvot $idTun $paikka
			luoVaatimusikkuna $paikka 0
		}
   	} else {
		set otsikko $k(vaatimuksenlisaaminen)
		set huomautus $k(numerotvirheellisia)
		tk_dialog .dialog_lv $otsikko $huomautus info 0 OK
	}
}

proc lisaaYhteys {} {
	global v idTun yi yiVaatimukset 
	global yiYhteydet tallennettu
	
	lappend yiYhteydet [$yi.fv.k.list get active] 
	$yi.fv.k.list delete active 
	$yi.fv.y.list delete 0 end 
	set x [lsort $yiYhteydet] 
	set yiYhteydet $x
	set yiVaatimukset [$yi.fv.k.list get 0 end]
	foreach i $yiYhteydet {$yi.fv.y.list insert end $i}
	if {[$yi.fv.k.list index end] == 0} {
		$yi.fv.b.buLisaa configure -state disabled
		set yiVaatimukset ""
 	}
	$yi.fv.b.buPoista configure -state normal
	$yi.fb.tallenna configure -state normal
	set tallennettu($yi) 0
}

proc listaaVaatimukset {} {
	global v idTun yiVaatimukset
	global yiYhteydet vaatimukset

	set yiVaatimukset ""
	set jolisatty 0	
	foreach i $vaatimukset {
		set idX "$i"
		if {[string compare $idTun $idX] != 0} {
			foreach j $yiYhteydet {
				if {[string compare $j $v($idX,nimi)] == 0} {
					set jolisatty 1
					break
				}
			}
			if {$jolisatty == 0 && $v($idX,nimi) != ""} {
				lappend yiVaatimukset "$v($idX,nimi)"
			}
		}
		set jolisatty 0	
	}
	set x [lsort -dictionary $yiVaatimukset] 
	set yiVaatimukset $x
	return $yiVaatimukset
}

proc luoVaatimusikkuna {pa vanhako} {
   	global c idTun k v vi 
	global tallennettu tietoLkm yiYhteydet 

	vaihdaKohdistin watch
	set vi .vaatimus-$idTun
	set tallennettu($vi) $vanhako
	set yiYhteydet ""
	if {[winfo exists $vi]} {
		wm deiconify $vi
	     	raise $vi
   	} else {
	     	toplevel $vi -class "Vaatimusikkuna"
		wm title $vi "$k(vaatimus): $v($idTun,nimi)"

		wm protocol $vi WM_DELETE_WINDOW {
			set vi .vaatimus-$idTun
			suljeVi $vi . 
		}

		bind $vi <FocusIn> {
			set alku [expr [string first "-" %W]+ 1]
			set loppu [string first "." [string range %W $alku end]]
			if {$loppu == -1} {
				set loppu end
				set idTun [string range %W $alku $loppu]
				if {$v($idTun,nimi) != ""} {
					laajennaSolmu "$v($idTun,solmu)" "root"
				} else {
					laajennaSolmu "$v($idTun,paikka)" "root"
				}
			}
		}

		set f $vi.fb
		frame $f -borderwidth 2 -height 16 
		pack $f -side bottom -anchor e -fill x
		button $f.poista -text "$k(poista)" -width 8 \
			-command {poistaVaatimus $idTun}
		button $f.tallenna -text "$k(tallenna)" -width 8 \
			-command {tallennaVaatimus $vi}
		button $f.sulje -text "$k(sulje)" -width 8 -command "suljeVi $vi ."

		pack $f.sulje -side right -padx 5 -pady 3
		pack $f.tallenna -side right -padx 5 -pady 3
		pack $f.poista -side right -padx 5 -pady 3

		set f $vi.frKanvaasi
		frame $f -borderwidth 2 
		pack $f -side left -anchor n -expand yes -fill both

		set ca $f.ca
		canvas $ca -scrollregion {0 0 500 1000} -width 500 \
			-height 350 -borderwidth 1 -xscrollcommand "$f.hscroll set" \
			-yscrollcommand "$f.vscroll set"
		scrollbar $f.vscroll -command "$ca yview"
		scrollbar $f.hscroll -orient horiz -command "$ca xview"

		grid $ca -in $f -row 0 -column 0 -rowspan 1 \
			-columnspan 1 -sticky news
		grid $f.vscroll -row 0 -column 1 -rowspan 1 \
			-columnspan 1 -sticky news
		grid $f.hscroll -row 1 -column 0 -rowspan 1 \
			-columnspan 1 -sticky news
		grid rowconfig $f 0 -weight 1 -minsize 0
		grid columnconfig $f 0 -weight 1 -minsize 0

		set f $ca.frPo 
		frame $f -relief ridge
		pack $f -side top -anchor e -fill x

		$ca create window 0 0 -window $f -anchor nw 
		luoVaatimusTekstiL Id $ca "$k(idtunnus)"
	 	$ca.frPo.frId.enId insert end "$idTun"
 		$ca.frPo.frId.enId configure -bg LightGray
	 	$ca.frPo.frId.enId configure -state disabled

		luoVaatimusTekstiL Ni $ca "$k(nimi)"
		luoVaatimusTekstiP Ku $ca "$k(kuvaus)"

		set f $ca.frPo.frYh 
		frame $f -borderwidth 2 -relief ridge -class Yhteydet
		pack $f -side top -anchor e -fill x
 
		frame $f.a -borderwidth 2 -width 16
		pack $f.a -side left -fill y
		label $f.a.lbYh -text "$k(yhteydet):" -justify left 
		button $f.a.buLisaa -text "$k(muokkaa)" -width 12 \
			-command {muokkaaYhteyksia} 
		pack $f.a.lbYh -side top  -anchor w  -padx 2   
		pack $f.a.buLisaa -side bottom -padx 2 -pady 2
		text $f.teksti -bg white -width 47 -height 3 -wrap none \
			-takefocus 0 -yscrollcommand "$f.vscroll set"  
		scrollbar $f.vscroll  -command "$f.teksti yview"
		pack $f.vscroll -side right -fill y -padx 1
		pack $f.teksti -side top -fill y

		$f.teksti delete 1.0 end
		for {set i 0} {$i < $tietoLkm} {incr i 1} {
			switch $c($i,tyyppi) {		
				<tekstiL>  {luoVaatimusTekstiL $i $ca "$c($i,nimi)"}  	
				<tekstiP>  {luoVaatimusTekstiP $i $ca "$c($i,nimi)"} 	
				<luokitus> {luoVaatimusLuokitus $i $ca "$c($i,nimi)"} 
			}
		}
		update
		set newx [lindex [$vi.frKanvaasi.ca bbox all] 2]
		set newy [lindex [$vi.frKanvaasi.ca bbox all] 3]
		$vi.frKanvaasi.ca configure -scrollregion "0 0 $newx $newy" 
		$vi.frKanvaasi.ca configure -width $newx 

		raise $vi
	  	focus $vi
		set tallennettu(tiedostoon) 0
		$vi.fb.poista configure -state disabled
    	}
	vaihdaKohdistin oletus
}

proc luoVaatimusLuokitus {i ca nimi} {
   	global c k vi
	
	set f $ca.frPo.fr$i
	frame $f -borderwidth 2 -height 16 -relief ridge
	pack $f -side top -anchor e -fill x -expand yes

	frame $f.a -borderwidth 2 -width 16
	pack $f.a -side left -fill y
 	label $f.a.lb$i -text "$nimi:" -justify left
	button $f.a.bu$i -text "$k(naytaperusteet)" -width 12 \
		-command "naytaPerusteet $i" 
	pack $f.a.lb$i  -side top -anchor w  -padx 2 
	pack $f.a.bu$i -side bottom -padx 2 -pady 2 

	set ff $ca.frPo.fr$i.frRb$i 
	frame $ff -borderwidth 1 -width 38
	pack $ff -side right -expand 1 -fill y
	set maara $c($i,lkm) 
	for {set j 1} {$j <= $maara} {incr j 1} {
	    	radiobutton $ff.rbu$j -text "$c($i,ln_$j)"  \
			-variable rbValinta($vi-$i) -value rbu$i-$j 
		pack $ff.rbu$j -side top -pady 2 -anchor nw 
	}
	$ff.rbu1 select 
}

proc luoVaatimusTekstiL {i ca nimi} {
   	global idTun

	set f $ca.frPo.fr$i 
	frame $f -borderwidth 2 -relief ridge
	pack $f -side top -anchor n -fill x 
 	label $f.lb$i -text "$nimi:" -justify left
	entry $f.en$i -width 50 -relief sunken -textvariable nimi$i-$idTun
 	pack $f.lb$i -side left -padx 5 -fill x
	pack $f.en$i -side right
 	$f.en$i delete 0 end
}  	

proc luoVaatimusTekstiP {i ca nimi} {
   	global k 

	set f $ca.frPo.fr$i 
	frame $f -borderwidth 2 -relief ridge
	pack $f -side top -anchor n -fill both -expand yes
	frame $f.a -borderwidth 2 
	pack $f.a -side left -fill both -expand yes
 	label $f.a.lb$i -text "$nimi:" -justify left
	button $f.a.muokkaa -text "$k(avaaeditoriin)" \
		-width 12 -justify left -command "after idle {avaaEditoriin $i}"
	pack $f.a.lb$i -side top -anchor w  -padx 2 	
	pack $f.a.muokkaa -side bottom -padx 2 -pady 2
	text $f.te$i -bg white -width 47 -wrap word -height 5 \
		-yscrollcommand "$f.vscroll set"
	scrollbar $f.vscroll -command "$f.te$i yview"
	pack $f.vscroll -side right -fill y -padx 1
	pack $f.te$i -side right -fill y
}

proc muokkaaYhteyksia {} {
	global idTun v k yi yiYhteydet
	global yiVaatimukset tallennettu 

	set yi .yhteysIkkuna
	set tallennettu($yi) 1
     	toplevel $yi -class "Yhteysikkuna"
	wm title $yi "$k(muokkaayhteyksia)"
	wm protocol $yi WM_DELETE_WINDOW {suljeYi $yi .vaatimus-$idTun}

	set f $yi.fb
	frame $f -borderwidth 2 -height 16 
	pack $f -side bottom -anchor e -fill x
	button $f.tallenna -text "$k(tallenna)" -width 8 \
		-command {tallennaYhteydet $yi} -state disabled
	button $f.sulje -text "$k(sulje)" -width 8 \
		-command {suljeYi $yi .vaatimus-$idTun}

	pack $f.sulje -side right -padx 5 -pady 3
	pack $f.tallenna -side right -padx 5 -pady 3

	set f $yi.fv 
	frame $f -borderwidth 2 -relief ridge -height 30 -width 70
	pack $f -side top -anchor e -expand yes -fill both

	set fk $f.k 
	frame $fk -borderwidth 2
	pack $fk -side left -expand 1 -fill both
 	label $fk.lbKVa -text "$k(kaikkivaatimukset)" -justify left 
	pack $fk.lbKVa -side top -padx 5    
	scrollbar $fk.scroll -command "$fk.list yview"
	listbox $fk.list -bg white -yscroll "$fk.scroll set" \
		-setgrid 1 -height 8 -width 25
	pack $fk.scroll -side right -fill y
	pack $fk.list -side top -expand 1 -fill both

	set fy $f.y 
	frame $fy -borderwidth 2
	pack $fy -side right -expand 1 -fill both
 	label $fy.lbYVa -text "$k(yhteysvaatimuksiin)" -justify left 
	pack $fy.lbYVa -side top -padx 5    
	scrollbar $fy.scroll -command "$fy.list yview"
	listbox $fy.list -bg white -yscroll "$fy.scroll set" \
		-setgrid 1 -height 8 -width 25
	pack $fy.scroll -side right -fill y
	pack $fy.list -side top -expand 1 -fill both

	set fb $f.b 
	frame $fb -borderwidth 2 -width 20
	pack $fb -side left -expand 1 -fill both -pady 30 
	button $fb.buLisaa -text "$k(lisaayhteys)" -width 18 \
		-command {lisaaYhteys} 
	pack $fb.buLisaa -side top -padx 4 -pady 10 
	button $fb.buPoista -text "$k(poistayhteys)" -width 18 \
		-command {poistaYhteys} -state disabled
	pack $fb.buPoista -side top -padx 5 -pady 10 

	foreach i $v($idTun,yhteydet) {$yi.fv.y.list insert end $i}
	if {[$yi.fv.y.list index end] != 0} {
	 	$yi.fv.b.buPoista configure -state normal
	}
	set yiYhteydet "$v($idTun,yhteydet)"

	foreach i [listaaVaatimukset] {$fk.list insert end $i}

	raise $yi
	focus $yi
	grab $yi
}

proc muutaNimetYhteyksiin {vanhaNimi uusiNimi idTunnus} {
	global v vaatimukset

	foreach i $vaatimukset {
		if {$v($i,id) != $idTunnus} {
			set lista $v($i,yhteydet) 
			set apulista ""
			set loytyi 0
			foreach yhteys $lista {
				if {[string compare $vanhaNimi $yhteys] == 0} {
					lappend apulista $uusiNimi
					set loytyi 1
				} else {
					lappend apulista $yhteys	
				}
			}
			if {$loytyi} {
				set v($i,yhteydet) $apulista
				paivitaVaatimuksenYhteydet "$i"
			}
		}
	}
}

proc naytaPerusteet {i} {
	global pi c k

	set pi($i) .perusteet-$i
   	if {[winfo exists $pi($i)]} {
     		wm deiconify $pi($i)
     		raise $pi($i)
	  	focus $pi($i)
	} else {
	  	toplevel $pi($i) -class "Perusteetikkuna" 
		wm title $pi($i) "$k(perusteet): $c($i,nimi)"
		set f $pi($i).f1
		frame $f -borderwidth 2 
		pack $f -side top  -expand yes -fill both 
		button $f.sulje -text "$k(sulje)" -width 8 -command "destroy $pi($i)"
		pack $f.sulje -side bottom -pady 3
		text $f.teksti -borderwidth 2 -bg LightGray -relief ridge \
		   -wrap word -width 50 -height 15 \
		   -yscrollcommand "$f.vscroll set"
		scrollbar $f.vscroll -command "$f.teksti yview"
		pack $f.vscroll -side right -fill y -padx 1
		pack $f.teksti -side top -expand yes -fill both 
		$f.teksti delete 1.0 end
		$f.teksti insert end $c($i,perusteet)
		$f.teksti configure -state disabled	
  		focus $pi($i)
	}
}

proc onkoNumero {rivi} {
	set lkm [string length $rivi] 
	set vastaus 1
	for {set i 0} {$i < $lkm} {incr i 1} {
	   set merkki [string index $rivi $i]
	   if {$merkki < 0 || $merkki > 9} {
		set vastaus 0
		break	
	   }
	}
	return $vastaus
}

proc paivitaVaatimuksenYhteydet {idTunnus} {
	global vi v

	set vi .vaatimus-$idTunnus
	set yhteydet $vi.frKanvaasi.ca.frPo.frYh.teksti
   	if {[winfo exists $vi]} {
		$yhteydet configure -state normal
		$yhteydet delete 1.0 end
		set laskuri 1
		foreach i $v($idTunnus,yhteydet) {
			set idYht [haeIdTunnusNimi $i]
			$yhteydet mark set pos "$laskuri.0"
			$yhteydet insert pos "$i\n" $idYht

			$yhteydet tag bind $idYht <Any-Enter> \
	 			"$yhteydet tag configure $idYht -background pink"
	
			$yhteydet tag bind $idYht <Any-Leave> \
				"$yhteydet tag configure $idYht -background {}"

			$yhteydet tag bind $idYht <Double-Button-1> \
			   "avaaVaatimusikkuna $idYht"	
			incr laskuri 1
		}
		$yhteydet configure -state disabled
	}
}

proc poistaUusista {idTun} {
	global uudet

	set apu ""
	set poistettu 0
	foreach i $uudet {
		if {$i != $idTun} {
			lappend apu $i
		} else {
			set poistettu 1
		}
	}
	if {$poistettu} {
		set uudet $apu
	}
}

proc poistaVaatimuksenYhteydet {nimi} {
	global v vaatimukset

	foreach i $vaatimukset {
		set lista $v($i,yhteydet)
		set apulista ""
		set onPoistettu 0
		foreach j $lista {
			if {[string compare $j $nimi] != 0} {
				lappend apulista $j
			} else {
				set onPoistettu 1
			}
		}
		if {$onPoistettu} {
			set v($i,yhteydet) $apulista
			paivitaVaatimuksenYhteydet "$i"
		}
	}
}

proc 	poistaVaatimuksetListasta {idTun} {
	global vaatimukset

	set apu ""
	foreach i $vaatimukset {
		if {$i != $idTun} {
			lappend apu $i
		}
	}
	set vaatimukset $apu
}

proc poistaVaatimus {idTunnus} {
	global v k

	set vi .vaatimus-$idTunnus
	set otsikko 	"$k(vaatimuksenpoistaminen)"
	set huomautus "\"$v($idTunnus,nimi)\" - $k(poistetaankovaatimus)"

	after idle {.dialog_pv.msg configure -wraplength 10c}
	set vastaus [tk_dialog .dialog_pv $otsikko \
		$huomautus question 1 $k(poista) $k(peruuta)]
		switch -- $vastaus {
    		0 {suoritaPoisto $idTunnus}
		1 {
			wm deiconify $vi
			focus $vi
		}
	}
}

proc poistaYhteys {} {
	global yi yiVaatimukset yiYhteydet tallennettu

	lappend yiVaatimukset [$yi.fv.y.list get active]
	$yi.fv.y.list delete active
	$yi.fv.k.list delete 0 end
	set x [lsort $yiVaatimukset] 
	set yiVaatimukset $x
	set yiYhteydet [$yi.fv.y.list get 0 end]
	foreach i $yiVaatimukset {$yi.fv.k.list insert end $i}
	if {[$yi.fv.y.list index end] == 0} {
	 	$yi.fv.b.buPoista configure -state disabled
		set yiYhteydet ""
	}
	$yi.fv.b.buLisaa configure -state normal
	$yi.fb.tallenna configure -state normal
	set tallennettu($yi) 0
}

proc sijoitaTietoKenttaan {idTun paikka tieto} {
   	global c v

		if {$tieto != ""} {
			$paikka insert end [string trimright $tieto]
		} else {
			$paikka insert end ""
		}	
}

proc suljeIkkuna {ikkuna paluuIkk} {
	destroy $ikkuna
	wm deiconify $paluuIkk
	focus $paluuIkk
	hierlist_redraw .list
	hierlist_expand_all .list
}

proc suljeVi {vaatimus paluuIkk} {
	global idTun k tallennettu uudet

	set otsikko 	"$k(vaatimusikkunansulkeminen)"	
	set huomautus 	"$k(tietojaeioletallennettu)"
	set onUusi 0
		foreach i $uudet {
			if {$idTun == $i} {
				set onUusi 1
			}
		}
	if {$tallennettu($vaatimus)} {
		tarkistaVaatimuksenMuutokset $idTun 
	}
	if {!$tallennettu($vaatimus)} {
		wm deiconify $vaatimus
		focus $vaatimus
		after idle {.dialog_svi.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_svi $otsikko \
		$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	tallennaVaatimus $vaatimus
				if {$tallennettu($vaatimus)} {
					suljeIkkuna $vaatimus $paluuIkk
				} else {
					wm deiconify $vaatimus
					focus $vaatimus
				} 
			}
			1 {	
				if {$onUusi} {   	
					poistaUusista $idTun
				}
				suoritaPoisto $idTun
				suljeIkkuna $vaatimus $paluuIkk
			}
    			2 {	wm deiconify $vaatimus
				focus $vaatimus
			}
		}
	} else {
		suljeIkkuna $vaatimus $paluuIkk
	}
}

proc suljeYi {ikkuna paluuIkk} {
	global k tallennettu 

	set otsikko 	"$k(yhteyksienmuokkausikkunansulkeminen)"	
	set huomautus 	"$k(tietojaeioletallennettu)"
	if {$tallennettu($ikkuna) == 0} {
		after idle {.dialog_syi.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_syi $otsikko \
		$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	tallennaYhteydet $ikkuna
				suljeIkkuna $ikkuna $paluuIkk
				}
			1 {	suljeIkkuna $ikkuna $paluuIkk
				}
    			2 {	wm deiconify $ikkuna
				focus $ikkuna
				}
		}
	} else {
		suljeIkkuna $ikkuna $paluuIkk
	}
}

proc suoritaPoisto {idTunnus} {
	global v tallennettu

	poistaVaatimusLuettelosta .list $idTunnus
	poistaVaatimuksetListasta $idTunnus
	set nimi "$v($idTunnus,nimi)"
 	asetaNollaArvot "$idTunnus" "$v($idTunnus,paikka)"
	destroy .vaatimus-$idTunnus
	poistaVaatimuksenYhteydet "$nimi"
	set tallennettu($idTunnus) 0			
	set tallennettu(tiedostoon) 0
	update
	wm deiconify .
	hierlist_expand_all .list
	focus .
}

proc tallennaVaatimus {vi} {
	global v c k idTun tietoLkm
	global rbValinta tallennettu vaatimukset

	set vi .vaatimus-$idTun
	set otsikko "$k(vaatimuksentallentaminen)"
	set huomautus1 "$k(uudellevaatimukselleeioleannettunimea)"
	set annettuNimi [string trim [$vi.frKanvaasi.ca.frPo.frNi.enNi get]] 
	set huomautus2 "'$annettuNimi' $k(vaatimusonjoolemassa)"
	if {$annettuNimi == ""} {
		after idle {.dialog_tv1.msg configure -wraplength 10c}
		tk_dialog .dialog_tv1 $otsikko $huomautus1 info 0 OK
		wm deiconify $vi 
		focus $vi.frKanvaasi.ca.frPo.frNi.enNi
	} else {
		set samanNiminen 0
		foreach i $vaatimukset {
			if {[string compare $i $idTun] != 0 && \
			   [string compare $annettuNimi $v($i,nimi)] == 0} {
				set samanNiminen 1 
				break
			} 
		}
		if {$samanNiminen} {
				after idle {.dialog_tv2.msg configure -wraplength 10c}
				tk_dialog .dialog_tv2 $otsikko $huomautus2 info 0 OK
				wm deiconify $vi 
				focus $vi.frKanvaasi.ca.frPo.frNi.enNi
				tkwait variable $vi.frKanvaasi.ca.frPo.frNi.enNi
				continue
		} else {
				set vanhaNimi $v($idTun,nimi)
				set uusiNimi [string trimright [$vi.frKanvaasi.ca.frPo.frNi.enNi get]]
				set nimeaMuutettu [string compare $vanhaNimi $uusiNimi]
				set v($idTun,id) $idTun 
				set v($idTun,nimi) $uusiNimi
				if {$nimeaMuutettu != 0} {
					muutaNimetYhteyksiin $vanhaNimi $uusiNimi $idTun
				}
				set v($idTun,kuvaus) [string trimright [$vi.frKanvaasi.ca.frPo.frKu.teKu get 1.0 end]]
				for {set i 0} {$i < $tietoLkm} {incr i 1} {
					switch $c($i,tyyppi) {		
						"<tekstiL>" {set v($idTun,$i) \
 							[string trimright [$vi.frKanvaasi.ca.frPo.fr$i.en$i get]]}  	
						"<tekstiP>" {set v($idTun,$i) \
							[string trimright [$vi.frKanvaasi.ca.frPo.fr$i.te$i get 1.0 end]]} 	
						"<luokitus>" {set v($idTun,$i) $rbValinta($vi-$i)}
					}
				}
				$vi.fb.poista configure -state normal
				$vi.fb.sulje  configure -state normal
				set tallennettu($vi) 1
				set tallennettu(tiedostoon) 0 
				poistaUusista $idTun

				wm title $vi "Vaatimus: $v($idTun,nimi)"

				lisaaVaatimusListaan .list $idTun "$v($idTun,paikka)"
				wm deiconify $vi 
				focus $vi
		}
	}
}

proc tallennaYhteydet {yi} {
	global idTun v
	global yiYhteydet tallennettu

	set vi .vaatimus-$idTun
	set v($idTun,yhteydet) $yiYhteydet
	paivitaVaatimuksenYhteydet $idTun
	$yi.fb.tallenna configure -state disabled
	set tallennettu($yi) 1 
	set tallennettu($vi) 0 
	set tallennettu(tiedostoon) 0
}

proc tarkistaVaatimuksenMuutokset {idTun} {
	global c v tietoLkm tallennettu rbValinta

	set vi .vaatimus-$idTun
	set x1 [string trim $v($idTun,nimi)]
	set x2 [string trimright [$vi.frKanvaasi.ca.frPo.frNi.enNi get]]
	if {$x1 != $x2} {
		set tallennettu($vi) 0
		set tallennettu(tiedostoon) 0
		return
	}
	set x1 [string trim $v($idTun,kuvaus)]
	set x2 [string trimright [$vi.frKanvaasi.ca.frPo.frKu.teKu get 1.0 end]]
	if {$x1 != $x2} {
		set tallennettu($vi) 0
		set tallennettu(tiedostoon) 0
		return
	}
	for {set i 0} {$i < $tietoLkm} {incr i 1} {
		switch $c($i,tyyppi) {
			"<tekstiL>" {
				set x1 [string trim $v($idTun,$i)] 
				set x2 [string trimright [$vi.frKanvaasi.ca.frPo.fr$i.en$i get]]
			}
			"<tekstiP>" {
				set x1 [string trim $v($idTun,$i)] 
				set x2 [string trimright [$vi.frKanvaasi.ca.frPo.fr$i.te$i get 1.0 end]]
			} 	
			"<luokitus>" {
				set x1 $v($idTun,$i) 
				set x2 $rbValinta($vi-$i)
			}
			default {continue}
		}
		if {$x1 != $x2} {
			set tallennettu($vi) 0
			set tallennettu(tiedostoon) 0
			return
		}
	}
}



proc lataaOletusasetukset {tiedosto} {
	global k m virhe virhelaskuri

	set otsikko $k(lataaoletukset) 
	set huomautus(editori) $k(oletuseditoriaeiole) 
	set huomautus(selain) $k(oletusselaintaeiole) 
	set virhelaskuri 1 

     	set t [open $tiedosto "r"]
	gets $t rivi
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-defaults -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}
    	while {! [eof $t] && !$virhe} {
		set rivi [lueRivi2 $t]
      	if {[string length $rivi] == 0} {
			continue
		} elseif {[regexp {<sfrm-nuolet>} $rivi]} {
			set rivi1 [lueRivi $t]
			set rivi2 [lueRivi2 $t]
			if {[regexp {</sfrm-nuolet>} $rivi2]} {
				if {[string length [string trim $rivi1]] != 0} {
					set m(sfrm-nuolet) $rivi1
				}	
			} else {
				set virhe 1
			}
		} elseif {[regexp {<editori>} $rivi]} {
			set rivi1 [lueRivi2 $t]
			set rivi2 [lueRivi2 $t]
			if {[regexp {</editori>} $rivi2]} {
				set m(editori) $rivi1
			} else {
				set virhe 1
			}
		} elseif {[regexp {<selain>} $rivi]} {
			set rivi1 [lueRivi2 $t]
			set rivi2 [lueRivi2 $t]
			if {[regexp {</selain>} $rivi2]} {
				set m(selain) $rivi1
				break
			} else {
				set virhe 1
				break
			}
		} else {
			set virhe 1
		}
	}
    	close $t
	if {! $virhe} {
		foreach i {editori selain} { 
			if {$m($i) == ""} {
				tk_dialog .dialog_loa1 $otsikko $huomautus($i) info 0 OK
			}
		}
	}
}

proc lataaVaatimusNumerot {tiedosto} {
	global k m virhe virhelaskuri

	set otsikko "$k(avaavm)"	
	set huomautus(alkunumero) $k(alkunumeroaeiole) 
	set huomautus(loppunumero) $k(loppunumeroaeiole) 
	set huomautus1 $k(numeroitaeioleannettu) 
	set huomautus2 "$tiedosto - $k(tarkistaoletusnumerot)"
	set nimi $m(tyonimi) 
	set loytyi 0
	set virhelaskuri 0 
     	set t [open $tiedosto "r"]
	gets $t rivi ; incr virhelaskuri
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-defaults -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}
    	while {! [eof $t] && !$virhe} {
		set rivi [lueRivi2 $t]
      	if {$rivi == "<$nimi>"} {
			set loytyi 1
		    	while {! [eof $t] && $rivi != "</$nimi>"} {
				set rivi [lueRivi2 $t]
				if {$rivi == "<alkunumero>"} {
					gets $t rivi1 ; incr virhelaskuri
					gets $t rivi2 ; incr virhelaskuri
					if {$rivi2 == "</alkunumero>"} {
						if {[onkoNumero $rivi1]} {
							set m(alkunumero) $rivi1
						} elseif {[string trim $rivi1] == 0} {
							set m(alkunumero) ""
							break
						} else {
							tk_dialog .dialog_lvn1 $otsikko $huomautus2 info 0 OK
							break
						}
					} else {
						set virhe 1 ; break
					}
				} elseif {$rivi == "<loppunumero>"} {
					gets $t rivi1 ; incr virhelaskuri
					gets $t rivi2 ; incr virhelaskuri
					if {$rivi2 == "</loppunumero>"} {
						if {[onkoNumero $rivi1]} {
							set m(loppunumero) $rivi1
							break
						} elseif {[string trim $rivi1] == 0} {
							set m(loppunumero) ""
							break
						} else {
							tk_dialog .dialog_lvn1 $otsikko $huomautus2 info 0 OK
							break
						}
					} else {
						set virhe 1 ; break
					}

				} else {
					set virhe 1 ; break
				}
			}
		}
	}
    	close $t
	if {!$loytyi} {
		tk_dialog .dialog_lvn1 $otsikko $huomautus1 info 0 OK
	}
	foreach i {alkunumero loppunumero} { 
		if {$m($i) == ""} {
			tk_dialog .dialog_lvn2 $otsikko $huomautus($i) info 0 OK
			set m(alkunumero) 0
			set m(loppunumero) -1
		}
	}
}

proc lueAlkuJaLoppunumerotMuuttujaan {tiedosto} {

	set lista "" 
	set t [open "$tiedosto" "r"]
	gets $t rivi
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-defaults -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}
    	while {![eof $t] && !$virhe && [string compare [string trim $rivi] "</selain>"] != 0} {
		gets $t rivi
	}
	while {![eof $t]} {
		gets $t rivi
		if {[string length [string trim $rivi]] != 0} {
			lappend lista $rivi
		}
 	}
	close $t
	return $lista
}

proc lueHierarkia {tiedosto} {
	global h virhe virhelaskuri 
	set laskuri 1	 
	set virhelaskuri 0 

	if {[array exists h]} {
		unset h
	} 
     	set t [open $tiedosto "r"]
	gets $t rivi ; incr virhelaskuri
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-hierarchy -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}
    	while {! [eof $t] && !$virhe} {
		set rivi [lueRivi $t] ; incr virhelaskuri
		if {[string length $rivi] == 0} {
			continue
		} elseif {[regexp {<otsikko.>} $rivi]} {
			set tasonro [string index $rivi 8]
			set rivi1 [lueRivi $t] ; incr virhelaskuri
			set rivi2 [lueRivi $t] ; incr virhelaskuri
			if {[regexp {</otsikko.>} $rivi2]} {
				set h($laskuri,nimi) $rivi1 
				set h($laskuri,taso) $tasonro
				incr laskuri
			} else {
				set virhe 1
			}
		} else {
			set virhe 1
		}
	}
    	close $t
    	return h
}

proc lueRivi {t} {

	while {! [eof $t]} {
		gets $t rivi 
		set r [string trim $rivi] 
      	if {[regexp {<--*} $r]} {
			continue  
		} else {
			return $r	
		}
	}
	if {[eof $t]} {
		return
	}
}

proc lueRivi2 {t} {
	global virhelaskuri

	while {! [eof $t]} {
		gets $t rivi ; incr virhelaskuri
		set r [string trim $rivi] 
      	if {[regexp {<--*} $r]} {
			continue  
		} elseif {[string length $r] == 0} {
			continue  
		} else {
			return $r	
		}
	}
	if {[eof $t]} {
		return
	}
}

proc lueVaatimusluokat {tiedosto} {
	global c tietoLkm virhe virhelaskuri

	set tietoLkm 0 
	set laskuri $tietoLkm
	set virhe 0
	set virhelaskuri 0  
	if {[array exists c]} {
		unset c
	} 
     	set t [open $tiedosto "r"]
	gets $t rivi ; incr virhelaskuri
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-contents -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}
    	while {! [eof $t] && !$virhe} {
		set rivi [lueRivi2 $t]
	   	if {! [eof $t]} {
			switch $rivi {
				"<tekstiL>" -
				"<tekstiP>" {
					set c($laskuri,nro) $laskuri
					set c($laskuri,tyyppi) $rivi
					set rivi1 [lueRivi2 $t]
					set rivi2 [lueRivi2 $t]
					if {$rivi2 == "</tekstiL>" || $rivi2 == "</tekstiP>"} {
						set c($laskuri,nimi) $rivi1
					} else {
						set virhe 1 ; break
					}
				}
				"<luokitus>" {
					set c($laskuri,perusteet) ""
					set c($laskuri,nro) $laskuri
					set c($laskuri,tyyppi) $rivi
					if {! [eof $t]} {set rivi [lueRivi2 $t]}
					set c($laskuri,nimi) $rivi
					if {! [eof $t]} {set rivi [lueRivi2 $t]}
					if {[onkoNumero $rivi]} {
						set c($laskuri,lkm) $rivi
						set lkm $rivi
					} else {
						{set virhe 1 ; break}
					}
		  			for {set i 1} {$i <= $lkm} {incr i 1} {
					   if {! [eof $t]} {
						set rivi [lueRivi2 $t]
						set c($laskuri,ln_$i) $rivi
					   }
					}
				   	if {! [eof $t]} {
						set rivi [lueRivi2 $t]
						if {[string compare $rivi "<perusteet>"] == 0} {
							set loppu 0
				    			while {! [eof $t] && ! $loppu} {
								set rivi [lueRivi2 $t]
								if {[string compare $rivi "</perusteet>"] == 0} {
									set loppu 1
									set rivi [lueRivi2 $t] 
								}
								if {! $loppu} {
									append c($laskuri,perusteet) "$rivi\n"
								}
							}
						} else {set virhe 1 ; break}
					} else {set virhe 1 ; break}
				}
				default {set virhe 1 ; break}
			}
			incr laskuri
		}
	}
    	close $t
	set tietoLkm $laskuri
    	return c
}

proc lueVaatimustiedot {tiedosto} {
	global idTun v virhe vaatimukset uudet

	set lkm 0
	set uudet "" 
	if {[array exists v]} {unset v} 

     	set t [open $tiedosto "r"]
	gets $t rivi
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-data -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}
    	while {! [eof $t] && !$virhe} {
		set rivi [lueRivi $t] 
		if {[regexp "<vaatimus_*" $rivi]} {
			set idTun [string range $rivi 10 [expr [string length $rivi] - 2]]
			incr lkm 
			lappend vaatimukset $idTun			
		}
		switch $rivi {
			<id> 	{
				set rivi1 [lueRivi $t]
				set v($idTun,id) $rivi1
			}
			<paikka> 	{
				set rivi1 [lueRivi $t]
				set v($idTun,paikka) $rivi1
			}
			<jarjnro> 	{
				set rivi1 [lueRivi $t]
				set v($idTun,jnro) $rivi1
			}
			<nimi> {
				set rivi1 [lueRivi $t]
				set v($idTun,nimi) $rivi1
			}
			<kuvaus> {
				set rivi1 [lueRivi $t]
				while {! [regexp "</kuvaus>" $rivi1]} {
					append r "$rivi1\n"	
					set rivi1 [lueRivi $t]
				}
				set v($idTun,kuvaus) $r
				set r ""
			}
			<yhteydet> 	{
				set rivi1 [lueRivi $t]
				set v($idTun,yhteydet) $rivi1
			}
		}
		if {[regexp "<tieto_*" $rivi]} {
					set i [string range $rivi 7 [expr [string length $rivi] - 2]]
					set rivi1 [lueRivi $t]
					while {! [regexp "</tieto_*" $rivi1]} {
				 		append r "$rivi1\n"	
				 		set rivi1 [lueRivi $t]
				 	}
					set v($idTun,$i) [string trimright $r]
					set r ""
		}
	}
    	close $t
	jarjestaVaatimukset
}

proc lueYleisetTiedot {tiedosto} {
	global v virhe

     	set t [open $tiedosto "r"]
	gets $t rivi
	set tarkistus [string compare [string trim $rivi] "<-- sfrm-general -->"] 
	if {$tarkistus == 0} {
		set virhe 0
	} else {
		set virhe 1
	}

	set v(r,yleista) ""
    	while {! [eof $t] && !$virhe} {
		gets $t rivi
      	if {[regexp {<--*} [string trim $rivi]]} {
			continue
		} elseif {[regexp {<yleiset>} [string trim $rivi]]} {
			continue		
		} elseif {[regexp {</yleiset>} [string trim $rivi]]} {
			break
		} else {
			lappend v(r,yleista) $rivi
		}
	}
    	close $t
}

proc onkoAsetuksetMuuttunut {ai sovellus} {
	global m tallennettu

	set vanha $m($sovellus)
	set uusi [$ai.f.e get]
	set muuttunut [string compare $uusi $vanha]
	if {$muuttunut != 0} {
		set palautettava $uusi
		set tallennettu(asetukset) 0
	} else {
		set palautettava 0
		set tallennettu(asetukset) 1
	}
	return $palautettava
}

proc tallennaAsetuksetTiedostoon {ai sovellus} {
	global k m tallennettu 

	set otsikko "$k(asetukset)"
	set huomautus "$k(asetuksettallennettiintiedostoon) '$m(kayttaja).rms'."
	set muuttunut [onkoAsetuksetMuuttunut $ai $sovellus]
	if {$muuttunut != 0} {
		set m($sovellus) $muuttunut
		set tiedosto [file join $m(sfrm-dir) $m(kayttaja).rms]
		set huomautus "$k(asetuksettallennettiintiedostoon) '$tiedosto'."
		set baktiedosto [file join $m(sfrm-dir) $m(kayttaja)-rms.bak]
		set oletusnumerot [lueAlkuJaLoppunumerotMuuttujaan $tiedosto]
		if {[file exists $tiedosto]} {
			file rename -force $tiedosto $baktiedosto
		}
		set aika [annaAika]
		set y [open "$tiedosto" "w"]
		puts $y "<-- sfrm-defaults -->"
		puts $y "<-- Tm on kyttjlle -->"
		puts $y "<-- '$m(kayttaja)' -->"
		puts $y "<-- liittyv oletusasetuksettiedosto -->"
		puts $y "<-- '$tiedosto' -->"
		puts $y "<-- $k(tekija): $m(kayttaja) -->"
		puts $y "<-- $k(paivays): $aika -->"
		if {[string trim $m(sfrm-nuolet)] != ""} {
   			puts $y "<sfrm-nuolet>"
			puts $y "$m(sfrm-nuolet)"	
   			puts $y "</sfrm-nuolet>"
   		}
		puts $y "<editori>"
		puts $y "$m(editori)"
   		puts $y "</editori>"
   		puts $y "<selain>"
		puts $y "$m(selain)"
   		puts $y "</selain>"
  		foreach x $oletusnumerot {
			puts $y "$x"
		}
		close $y
		set tallennettu(asetukset) 1
		tk_dialog .dialog_tat $otsikko $huomautus info 0 OK
		wm deiconify $ai ; focus $ai
	}
}

proc tallennaRaportti {ri} {
	global v c h k m cb
	global tietoLkm rbValinta
	global tallennettu

	tallennaRaportinPerusteet $ri
	set f $ri.frKanvaasi.ca.frPo
      set suodatin {
	   {{HTML-files} {.html .htm}}
 	   {{All files} {*}}
      }

	set tallennettu(r) 0
	set tiedosto [tk_getSaveFile -title "$k(tallennaraportti)" \
		-filetypes $suodatin -defaultextension .html]
	if {$tiedosto != ""} {
		if {[file exists "$tiedosto"]} {
			file rename -force "$tiedosto" "[file rootname $tiedosto].bak"
		}
		set otsikko "[string trim [$f.frRn.enRn get]]"
		set aika [annaAika]
		set a [open "$tiedosto" "w"]
		puts $a "<html>"
		puts $a "<head>"
		puts $a "<title>$otsikko - Sfrm v$m(sfrm-versio)</title>"
		puts $a "</head>"
		puts $a "<body>"
		puts $a "<table border=0 cellspacing=0 width=300>"
		puts $a "<tr><td>$k(tekija): $m(kayttaja)</td><td>$k(paivays): $aika</td></tr>"
		puts $a "</table><br><hr><br>"
		foreach rivi $v(r,yleista) {
			puts $a "$rivi"
		}
		puts $a "<br><hr><br>"
		puts $a "<h3>$k(raportinmuodostamisperusteet)</h3>"
		puts $a "<h4>$k(raportinesitystapa):</h4>"
		puts $a "$v(r,esitystapa)"
		puts $a "<h4>$k(vaatimustenvalintaperusteet):</h4>"
		set valitutperusteet [haeTulostukseenValitutperusteet]
		if {$v(r,p_kaikki)} {
			puts $a "$k(kaikki)"
		} else {
			puts $a "<table border=0 cellspacing=1 width=500>"
			puts $a "<tr><td valign=top>$k(valintaperuste):</td><td>$k(valintaehto):</td></tr>"
			foreach peruste $valitutperusteet {
				switch -- $peruste {
					"nimi" 	{puts $a "<tr><td valign=top>$k(nimi)</td><td>$v(r,e_nimi)</td></tr>"}
					"kuvaus" 	{puts $a "<tr><td valign=top>$k(kuvaus)</td><td>$v(r,e_kuvaus)</td></tr>"}
					"yhteydet" 	{puts $a "<tr><td valign=top>$k(yhteydet)</td><td>$v(r,e_yhteydet)</td></tr>"}
					default 	{puts $a "<tr><td valign=top>$c($peruste,nimi)</td><td>$v(r,e_$peruste)</td></tr>"}
				}
			}
			puts $a "</table>"
		}
		puts $a "<h4>$k(vaatimuksestaesitettavattiedot):</h4>" 
		set tietolista [haeTulostettavatTiedot]
		if {$v(r,kaikki)} {
			puts $a "$k(kaikki)<br>"
		} else {
			puts $a "$k(nimi)<br>"
			foreach tieto $tietolista {
				if {$tieto == "kuvaus" || $tieto == "yhteydet"} {
					puts $a "$k($tieto)<br>"
				} else {
					puts $a "$c($tieto,nimi)<br>"
				}
			} 
			puts $a "</table>"
		}
		puts $a "<br><hr><br>"

		set tuloslista [haeTulostettavatVaatimukset $ri $valitutperusteet]
		if {$rbValinta(esitystapa) == "b1"} {
			tallennaRaporttiOtsikoilla $a $tuloslista $tietolista 
		} else {
			tallennaRaporttiLuettelona $a $tuloslista $tietolista 
		}
		puts $a "</body>"
		puts $a "</html>"
		close $a
		set tallennettu(r) 1
	}
	avataankoSelaimeen $ri $tiedosto 
}

proc tallennaRiviTiedostoon {a tieto} {
	if {$tieto != ""} {
		puts $a "[string trimright $tieto]"
	} else {
		puts $a ""
	}
}

proc tallennaVaatimuksetTiedostoon {} {
   	global k m v tietoLkm 
	global vmTiedosto tallennettu vaatimukset
	vaihdaKohdistin watch

	set oliUusiTallentamaton 0
	set otsikko "$k(tallennatiedostoon)"
	set huomautus1 "$k(vaatimuksettallennettiintiedostoon) '$vmTiedosto.rmd'."
	set huomautus2 "$k(uusienvaatimustentietojaeitallennettu)" 	
	set aika [annaAika]	

	if {[file exists "$vmTiedosto.rmd"]} {
		file rename -force "$vmTiedosto.rmd" "$vmTiedosto-rmd.bak"
	}
	set a [open "$vmTiedosto.rmd" "w"]
	puts $a "<-- sfrm-data -->"
	puts $a "<-- Tm on vaatimusmrittelyyn -->"
	puts $a "<-- '$vmTiedosto' -->"
	puts $a "<-- liittyv vaatimusten tallennustiedosto -->"
	puts $a "<-- '$vmTiedosto.rmd' -->"
	puts $a "<-- $k(tekija): $m(kayttaja) -->"
	puts $a "<-- $k(paivays): $aika -->"
	foreach i $vaatimukset {
	   if {$v($i,nimi) != ""} {
	   	puts $a "<vaatimus_$i>"
   		puts $a "<id>"
   		tallennaRiviTiedostoon $a "$v($i,id)"
   		puts $a "</id>"

   		puts $a "<paikka>"
   		tallennaRiviTiedostoon $a "$v($i,paikka)"
   		puts $a "</paikka>"

   		puts $a "<jarjnro>"
   		tallennaRiviTiedostoon $a "$v($i,jnro)"
   		puts $a "</jarjnro>"

   		puts $a "<nimi>"
   		tallennaRiviTiedostoon $a "$v($i,nimi)"
   		puts $a "</nimi>"

   		puts $a "<kuvaus>"
   		tallennaRiviTiedostoon $a "$v($i,kuvaus)"
   		puts $a "</kuvaus>"

   		puts $a "<yhteydet>"
   		tallennaRiviTiedostoon $a "$v($i,yhteydet)"
   		puts $a "</yhteydet>"

   		for {set j 0} {$j < $tietoLkm} {incr j 1} {
			puts $a "<tieto_$j>"
			tallennaRiviTiedostoon $a "$v($i,$j)"
			puts $a "</tieto_$j>"
   		}
   		puts $a "</vaatimus_$i>\n"
	   } else {
		set oliUusiTallentamaton 1
	   }
	}
	close $a
	set tallennettu(tiedostoon) 1

	after idle {.dialog_tvt1.msg configure -wraplength 10c}
	tk_dialog .dialog_tvt1 $otsikko $huomautus1 info 0 OK
	if {$oliUusiTallentamaton} {
		after idle {.dialog_tvt2.msg configure -wraplength 10c}
		tk_dialog .dialog_tvt2 $otsikko $huomautus2 info 0 OK
	}
	vaihdaKohdistin oletus
}

proc tallennaYleisetTiedostoon {} {
	global k m v vmTiedosto tallennettu 

	set otsikko "$k(yleistiedot)"
	set huomautus "$k(yleistiedottallennettiintiedostoon) '$vmTiedosto.rmg'."
	set muuttunut [onkoYleisetMuuttunut]
	if {$muuttunut != 0} {
		set v(r,yleista) $muuttunut
		if {[file exists "$vmTiedosto.rmg"]} {
			file rename -force "$vmTiedosto.rmg" "$vmTiedosto-rmg.bak"
		}
		set aika [annaAika]
		set y [open "$vmTiedosto.rmg" "w"]
		puts $y "<-- sfrm-general -->"
		puts $y "<-- Tm on vaatimusmrittelyyn -->"
		puts $y "<-- '$vmTiedosto' -->"
		puts $y "<-- liittyv yleistiedot -tiedosto -->"
		puts $y "<-- '$vmTiedosto.rmg' -->"
		puts $y "<-- $k(tekija): $m(kayttaja) -->"
		puts $y "<-- $k(paivays): $aika -->"
   		puts $y "<yleiset>"
		foreach rivi $v(r,yleista) {
			puts $y "$rivi"
		}
   		puts $y "</yleiset>"
		close $y
		paivitaRaporttiIkkuna
		set tallennettu(yleiset) 1
		tk_dialog .dialog_tyt $otsikko $huomautus info 0 OK
	}
}


proc tulostaRaporttiinVaatimus {a idX tietolista} {
	global c k v  	

	puts $a "<h4>$v($idX,nimi)</h4>"
	puts $a "<table border=0 cellspacing=0 width=100%>"
	foreach x $tietolista {
		if {$x == "kuvaus"} {
			set nimi "$k(kuvaus)"
			set teksti $v($idX,$x)
		} elseif {$x == "yhteydet"} {
			set teksti ""	
			set nimi "$k(yhteydet)"
 			set apulista [lsort -dictionary $v($idX,$x)]
 			foreach yht $apulista {
				append teksti "$yht<br>"
			}
		} else {
			set nimi "$c($x,nimi)"							
			if {$c($x,tyyppi) == "<luokitus>"} {
				set y "$v($idX,$x)"
				set alku [expr [string first - $y] + 1]
				set loppu [expr [string length $y] - 1]
				set valittu [string range $y $alku $loppu]
				set teksti "$c($x,ln_$valittu)"								
			} elseif {$c($x,tyyppi) == "<tekstiP>"} {
				set teksti $v($idX,$x)
			} else {
				set teksti "$v($idX,$x)"
			}
		}
		puts $a "<tr><td width=15% valign=top>$nimi:</td> \
			<td valign=top>$teksti</td></tr>"
	}
	puts $a "</table>"
}

proc avataankoSelaimeen {ri tiedosto} {
	global k tallennettu  
	if {$tallennettu(r)} {
		set otsikko "$k(tallennaraportti)"  
		set huomautus "$k(raporttiontallennettu) '$tiedosto'. \
			$k(haluatkoavataraportinselaimeen)" 

		after idle {.dialog_tr.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_tr $otsikko \
			$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	raporttiAvaa $tiedosto
				wm deiconify $ri
				focus $ri
			}
			1 {
				wm withdraw $ri
				wm deiconify .
				raise . 
				focus .
			}
    			2 {	
				wm deiconify $ri
				focus $ri
			}
		}
	} else {
		wm withdraw $ri
		raise .
		wm deiconify . 
		focus .
	}
}

proc 	jarjestaVaatimuksetNimenMukaan {tuloslista} {
	global v

	set apulista "" ; set apuapulista "" ; set lista ""
	foreach id $tuloslista {
		lappend apulista "$v($id,nimi)"
	}
 	set apuapulista [lsort -dictionary $apulista] 
	foreach nimi $apuapulista {
		lappend lista [haeIdTunnusNimi $nimi]
	}
	return $lista
}

proc haeLuokitusEhdonMukaiset {i} {
	global c v vaatimukset ehto

	set lista "" ; set apulista "" 
	set maara $c($i,lkm)
	foreach x $vaatimukset {
		set valittu $v($x,$i)
		for {set j 1} {$j <= $maara} {incr j 1} {
			if {$ehto($i-$j) == 1 && $valittu == "rbu$i-$j"} {
				lappend apulista $x
			}
		}
	}
 	set lista [lsort -dictionary $apulista]
	set apulista ""
	foreach nimi $lista {
		if {[lsearch $apulista $nimi] == -1} {
			lappend apulista $nimi 
		}
	}
  	return $apulista
}

proc haeNeJoistaYhteys {ve} {
	global v vaatimukset 

	set lista "" ; set apulista ""
	foreach i $vaatimukset {
		foreach j $v($i,yhteydet) {
			set idX [haeIdTunnusNimi $j]
			if {[string match $ve "$v($idX,nimi)"] == 1} {
				lappend apulista "$v($i,id)"
			} 
		}
	}
	set lista [lsort -dictionary $apulista] 
	set apulista ""
	foreach nimi $lista {
		if {[lsearch $apulista $nimi] == -1} {
			lappend apulista $nimi 
		}
	}
	return $apulista
}

proc haeTulostettavatTiedot {} {
	global cb tietoLkm vaatimukset

	set tietolista ""
	set luokka {kuvaus yhteydet} 
	for {set j 0} {$j < $tietoLkm} {incr j} {lappend luokka $j}
	if {$cb(kaikki)} {
		set tietolista $luokka 
	} else {
		foreach x $luokka {
			if {$cb($x)} {
				lappend tietolista $x
			}
		}
	}
	return $tietolista	
}

proc haeTulostettavatVaatimukset {ri valitutperusteet} {
	global c cb ehto tietoLkm
	global vaatimukset rbValinta

	set f $ri.frKanvaasi.ca.frPo.fPe 
	set esitystapa $rbValinta(esitystapa)
	set tuloslista ""
  	if {[array exists tulostettavat]} {unset tulostettavat}

	if {[lsearch $valitutperusteet "kaikki"] != -1} {
		set tuloslista $vaatimukset
	} else {
	   foreach j $valitutperusteet {
		set tulostettavat($j) ""
		switch -- $j {
			"yhteydet" {
				set ve [$f.yhteydet.enyhteydet get] 
				set tulostettavat($j) [haeNeJoistaYhteys $ve]
			}
			"nimi" -
			"kuvaus" {
				set ve [$f.$j.en$j get]
				set tulostettavat($j) [haeValintaEhdonMukaiset $j $ve]
			}
			default {
				if {[onkoEhtoLuokitus $j]} {
					set tulostettavat($j) [haeLuokitusEhdonMukaiset $j]
				} else {
					set ve [$f.$j.en$j get]
					set tulostettavat($j) [haeValintaEhdonMukaiset $j $ve]
				}
			}
		}
	   }
	   set apulista ""
	   foreach idTun $vaatimukset {
		if {[llength $valitutperusteet] == 0} {
			set onkaikissa 0 } else { set onkaikissa 1 }
		foreach j $valitutperusteet {
			if {[lsearch $tulostettavat($j) $idTun] == -1} {
				set onkaikissa 0
				break
			}	
		}
		if {$onkaikissa} {
			lappend tuloslista $idTun
		}
	   }
	}
	return $tuloslista
}

proc haeTulostukseenValitutperusteet {} {
	global ehto tietoLkm

	set valitutperusteet ""
	foreach i {kaikki nimi kuvaus yhteydet} {lappend ehdot $i}
	for {set j 0} {$j < $tietoLkm} {incr j 1} {lappend ehdot $j}

	foreach i $ehdot {
		if {$ehto($i) == 1 } { 
			lappend valitutperusteet "$i"
		}
	}
	return $valitutperusteet
}

proc haeValintaEhdonMukaiset {j ve} {
	global v vaatimukset 

	set lista "" ; set apulista ""
	foreach i $vaatimukset {
		set teksti $v($i,$j)
		if {[string match $ve $teksti] == 1} {
			lappend apulista "$v($i,id)"
		}
	}
	set lista [lsort -dictionary $apulista] 
	set apulista ""
	foreach nimi $lista {
		if {[lsearch $apulista $nimi] == -1} {
			lappend apulista $nimi 
		}
	}
	return $apulista
}

proc luoRaporttiIkkuna {} {
   	global c k v avattuVM tietoLkm tallennettu
	
	vaihdaKohdistin watch
	set ri .raportti
	set otsikko "$k(raportinluominen)"
	set huomautus "$k(vaatimusmaarittelyaeioleavattu)"	

   if {$avattuVM == 1} {
	if {[winfo exists $ri]} {
		wm deiconify $ri
	     	raise $ri
   	} else {
	     	toplevel $ri -class "Raporttikkuna"
		wm title $ri "$k(raportinluominen)"

		wm protocol $ri WM_DELETE_WINDOW "suljeRi $ri"

		set f $ri.fb
		frame $f -borderwidth 2 -height 16 
		pack $f -side bottom -anchor e -fill x
		button $f.tyhjenna -text "$k(tyhjennatiedot)" -width 12 \
			-command "tyhjennaRaporttiIkkuna $ri"
		button $f.luo -text "$k(luo)" -width 8 \
			-command "tallennaRaportti $ri"
		button $f.sulje -text "$k(sulje)" -width 8 -command "suljeRi $ri"
		pack $f.sulje -side right -padx 5 -pady 3
		pack $f.luo -side right -padx 5 -pady 3
		pack $f.tyhjenna -side right -padx 5 -pady 3

		set f $ri.frKanvaasi
		frame $f -borderwidth 2 
		pack $f -side top -anchor n -expand yes -fill both

		set ca $f.ca
		canvas $ca -scrollregion {0c 0c 500 1000} -width 500 \
			-height 500 -bd 1 -xscrollcommand "$f.hscroll set" \
			-yscrollcommand "$f.vscroll set"
		scrollbar $f.vscroll -command "$ca yview"
		scrollbar $f.hscroll -orient horiz -command "$ca xview"

		grid $ca -in $f -row 0 -column 0 -rowspan 1 \
			-columnspan 1 -sticky news
		grid $f.vscroll -row 0 -column 1 -rowspan 1 \
			-columnspan 1 -sticky news
		grid $f.hscroll -row 1 -column 0 -rowspan 1 \
			-columnspan 1 -sticky news
		grid rowconfig $f 0 -weight 1 -minsize 0
		grid columnconfig $f 0 -weight 1 -minsize 0

		set f $ca.frPo 
		frame $f -relief ridge
		$ca create window 0c 0c -window $f -anchor nw 

		luoVaatimusTekstiL Rn $ca "$k(raportinnimi)"
		luoVaatimusTekstiP Yt $ca "$k(yleistiedot)" 

 		$ca.frPo.frYt.a.muokkaa configure -state disabled -text "" -relief flat  
		$f.frYt.teYt delete 1.0 end
		foreach rivi $v(r,yleista) {
			$f.frYt.teYt insert end "$rivi\n"
		}
		$f.frYt.teYt delete {end - 1 chars} end
		$f.frYt.teYt configure -bg LightGray
		$f.frYt.teYt configure -state disabled
		set f $ca.frPo.fEt 
		frame $f -bd 2 -relief ridge
		pack $f -side top -anchor n -fill both -expand yes -pady 4

		frame $f.a -bd 2 
		pack $f.a -side left -fill x
	 	label $f.a.lb -text "$k(raportinesitystapa):" -justify left
		pack $f.a.lb -side top -anchor w  -padx 2 

		frame $f.b -bd 2 -width 40
		pack $f.b -side right -expand 1 -fill y
	    	radiobutton $f.b.b1 -text "$k(raporttiluettelolla)"  \
			-variable rbValinta(esitystapa) -value b1 
	    	radiobutton $f.b.b2 -text "$k(raporttiluettelotta)"  \
			-variable rbValinta(esitystapa) -value b2 
		pack $f.b.b1 $f.b.b2 -side top -pady 2 -anchor nw 
		$f.b.b1 select 
		set f $ca.frPo.fPe 
		frame $f -bd 2 -relief ridge
		pack $f -side top -anchor n -fill both -expand yes -pady 4

		frame $f.a -bd 2 
		pack $f.a -side top -fill x 
	 	label $f.a.lb -text "$k(vaatimustenvalintaperusteet):" 
		pack $f.a.lb  -side left -anchor w -padx 5 -fill x

		frame $f.b -bd 2 
		pack $f.b -side top -fill x 
	 	label $f.b.lb1 -text "$k(valintaperuste):" 
	 	label $f.b.lb2 -text "$k(valintaehto):" -width 30  
		pack $f.b.lb1  -side left -anchor w -padx 5 -fill x
		pack $f.b.lb2  -side right -anchor w -padx 5 -expand 1

		frame $f.all -bd 2 -relief groove
		pack $f.all -side top -fill x
	    	checkbutton $f.all.cbAll -text "$k(kaikki)" -variable "ehto(kaikki)"
		pack $f.all.cbAll -side left -padx 5 -anchor w 

		frame $f.nimi -bd 2 -relief groove
		pack $f.nimi -side top -fill x
	    	checkbutton $f.nimi.cbnimi -text "$k(nimi)" -variable "ehto(nimi)" 
		entry $f.nimi.ennimi -width 40 -relief sunken -textvariable "ehto(nimi-txt)"
		pack $f.nimi.cbnimi -side left -padx 5 
		pack $f.nimi.ennimi -side right -padx 5 -fill x

		frame $f.kuvaus -bd 2 -relief groove
		pack $f.kuvaus -side top -fill x
	    	checkbutton $f.kuvaus.cbkuvaus -text "$k(kuvaus)" -variable "ehto(kuvaus)" 
		entry $f.kuvaus.enkuvaus -width 40 -relief sunken
		pack $f.kuvaus.cbkuvaus -side left -padx 5 
		pack $f.kuvaus.enkuvaus -side right -padx 5 -fill x

		frame $f.yhteydet -bd 2 -relief groove
		pack $f.yhteydet -side top -fill x
	    	checkbutton $f.yhteydet.cbyhteydet -text "$k(yhteydet)" -variable "ehto(yhteydet)" 
		entry $f.yhteydet.enyhteydet -width 40 -relief sunken
		pack $f.yhteydet.cbyhteydet -side left -padx 5 -anchor nw 
		pack $f.yhteydet.enyhteydet -side right -padx 5 -fill x

		for {set i 0} {$i < $tietoLkm} {incr i 1} {
			frame $f.$i -bd 2 -relief groove
			pack $f.$i -side top -fill x
		    	checkbutton $f.$i.cb$i -text "$c($i,nimi)" -variable "ehto($i)"
			pack $f.$i.cb$i -side left -padx 5 -anchor nw

			switch $c($i,tyyppi) {		
				<tekstiL> -  	
				<tekstiP>  {
					entry $f.$i.en$i -width 40 -relief sunken
					pack $f.$i.en$i -side right -padx 5 -fill x
				}
				<luokitus> {
					set ff $f.$i.fcb$i
					frame $ff -bd 2 -width 20
					pack $ff -side right -expand 1 -fill y
					set maara $c($i,lkm)
					for {set j 1} {$j <= $maara} {incr j 1} {
	    					checkbutton $ff.cb$j -text "$c($i,ln_$j)"  \
						-variable "ehto($i-$j)"
						pack $ff.cb$j -side top -anchor nw 
					}
				} 
			}
		}
		set f $ca.frPo.fVa 
		frame $f -bd 2 -relief ridge
		pack $f -side top -anchor n -fill both -expand yes -pady 4

		frame $f.a -bd 2 -width 16
		pack $f.a -side left -fill y
	 	label $f.a.lb -text "$k(vaatimuksestaesitettavattiedot):" -justify left
		pack $f.a.lb  -side top -anchor w  -padx 2 

		set fcb $f.cb 
		frame $fcb -bd 1 -width 38
		pack $fcb -side right -expand 1 -fill y

	    	checkbutton $fcb.cbKaikki -text "$k(kaikki)" -variable "cb(kaikki)"
	    	checkbutton $fcb.cbNimi -text "$k(nimi)" -variable "cb(nimi)"
	    	checkbutton $fcb.cbKuvaus -text "$k(kuvaus)" -variable "cb(kuvaus)"
	    	checkbutton $fcb.cbYhteydet -text "$k(yhteydet)" -variable "cb(yhteydet)"

		pack $fcb.cbKaikki $fcb.cbNimi $fcb.cbKuvaus $fcb.cbYhteydet -side top -pady 2 -anchor nw 
	    	$fcb.cbNimi select
	    	$fcb.cbNimi configure -state disabled

		for {set i 0} {$i < $tietoLkm} {incr i 1} {
		    	checkbutton $fcb.cb$i -text "$c($i,nimi)" -variable "cb($i)"
			pack $fcb.cb$i -side top -pady 2 -anchor nw 
		}
		update
		set newx [lindex [$ri.frKanvaasi.ca bbox all] 2]
		set newy [lindex [$ri.frKanvaasi.ca bbox all] 3]
		$ri.frKanvaasi.ca configure -scrollregion "0 0 $newx $newy" 
		$ri.frKanvaasi.ca configure -width $newx 

		set tallennettu(r) 0
		raise $ri
		focus $ri
	}
    } else {
	tk_dialog .dialog_rl $otsikko $huomautus info 0 OK
    }
    vaihdaKohdistin oletus
}

proc onkoEhtoLuokitus {j} {
	global c 
	if {$c($j,tyyppi) == "<luokitus>"} { 
		return 1 
	} else {
		return 0
	}
}

proc paivitaRaporttiIkkuna {} {
	global v

	if {[winfo exists .raportti]} {
		set f .raportti.frKanvaasi.ca.frPo.frYt.teYt
		$f configure -state normal
		$f delete 1.0 end
		foreach rivi $v(r,yleista) {
			$f insert end "$rivi\n"
		}
		$f delete {end - 1 chars} end
		$f configure -state disabled
	}
}

proc raporttiAvaa {tiedosto} {
	global k m

	set browser $m(selain)
	if {$tiedosto == ""} {
	      set suodatin {
		   {{HTML-files} {.htm .html}}
	 	   {{All files} {*}}	 				
      	}
	      set tiedosto [tk_getOpenFile -title "$k(avaaraportti)" -filetypes $suodatin]
	}
	vaihdaKohdistin watch
      if {$tiedosto != ""} {
		if {$browser == ""} {
			set otsikko $k(lataaoletukset) 
			set huomautus $k(oletusselaintaeiole)
			vaihdaKohdistin oletus
			tk_dialog .dialog_ra $otsikko $huomautus info 0 OK
		} else {
			set path [file dirname $tiedosto]
			set file [file tail $tiedosto]
			if {[catch {exec $browser "$path/$file" &} errmsg]} {
				set otsikko $k(avaaraportti) 
				set huomautus "$k(virheavattaessaraporttia) $errmsg"
				tk_dialog .dialog_avm1 $otsikko $huomautus info 0 OK
			} 
		}
	}
	vaihdaKohdistin oletus
}

proc suljeRi {ri} {
	global tallennettu k

	set otsikko "$k(raporttiikkunansulkeminen)"
	set huomautus "$k(tietojaeioletallennettu)"
	if {!$tallennettu(r)} {
		wm deiconify $ri
		focus $ri
		after idle {.dialog_sri.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_sri $otsikko \
		$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	tallennaRaportti $ri}
			1 {	
				wm withdraw $ri
				wm deiconify .
				raise . 
				focus .
			}
    			2 {	wm deiconify $ri ; focus $ri}
		}
	} else {
		wm withdraw $ri
		raise .
		wm deiconify . 
		focus .
	}
}

proc tallennaRaportinPerusteet {ri} {
	global k v c cb rbValinta ehto tietoLkm tallennettu

	if {$rbValinta(esitystapa) == "b1"} {
		set v(r,esitystapa) "$k(raporttiluettelolla)"
	} else {
		set v(r,esitystapa) "$k(raporttiluettelotta)"
	}
	set f $ri.frKanvaasi.ca.frPo
	set v(r,p_kaikki) $ehto(kaikki)
	set v(r,p_n) $ehto(nimi)
	set v(r,p_k) $ehto(kuvaus)
	set v(r,p_y) $ehto(yhteydet)
	for {set i 0} {$i < $tietoLkm} {incr i 1} {
		set v(r,p_$i) $ehto($i)
	}
	set v(r,e_nimi) [$f.fPe.nimi.ennimi get]
	set v(r,e_kuvaus) [$f.fPe.kuvaus.enkuvaus get]
	set v(r,e_yhteydet) [$f.fPe.yhteydet.enyhteydet get]
	for {set i 0} {$i < $tietoLkm} {incr i 1} {
		switch $c($i,tyyppi) {		
			<tekstiL> -  	
			<tekstiP>  {
				set v(r,e_$i) [$f.fPe.$i.en$i get]
				}
				<luokitus> {
					set maara $c($i,lkm)
					set v(r,e_$i) ""
					for {set j 1} {$j <= $maara} {incr j 1} {
						if {$ehto($i-$j)} {
							append v(r,e_$i) "$c($i,ln_$j) "
						}
					}
				}
		}
	}
	set v(r,nimi) [$f.frRn.enRn get]
	set v(r,kaikki) $cb(kaikki)
	set v(r,n) $cb(nimi)
	set v(r,k) $cb(kuvaus)
	set v(r,y) $cb(yhteydet)
	for {set i 0} {$i < $tietoLkm} {incr i 1} {
		set v(r,$i) $cb($i)
	}
} 

proc tallennaRaporttiLuettelona {a tuloslista tietolista } {
	set aakkoslista [jarjestaVaatimuksetNimenMukaan $tuloslista]
	foreach vaatimus $aakkoslista {
		tulostaRaporttiinVaatimus $a $vaatimus $tietolista
		puts $a "<br><hr><br>"		
	}
}

proc tallennaRaporttiOtsikoilla {a tuloslista tietolista} {

	set apu [lueHierarkiaListaan]
	foreach rivi $apu {
		set onOtsikko [onkoOtsikko $rivi]
		if {$onOtsikko} {
			puts $a "<h3>$rivi</h3>"
		} else {
			set idX [haeIdTunnusNimi [string trim $rivi]]
		   	if {[lsearch $tuloslista $idX] != -1} {		
				tulostaRaporttiinVaatimus $a $idX $tietolista
			}
		}
	}
}

proc tyhjennaRaporttiIkkuna {ri} {
	global c cb ehto tietoLkm rbValinta tallennettu

	set f $ri.frKanvaasi.ca.frPo
	$f.frRn.enRn delete 0 end
	set rbValinta(esitystapa) b1
	set lista1 {kaikki nimi kuvaus yhteydet}
	for {set i 0} {$i < $tietoLkm} {incr i 1} {lappend lista2 $i}
	set kokolista [concat $lista1 $lista2]  
	foreach j $kokolista {
		if {$j != "nimi"} {
			set cb($j) 0
		}
		set ehto($j) 0
	}
	foreach j $lista2 {
		if {$c($j,tyyppi) != "<luokitus>"} {
			$f.fPe.$j.en$j delete 0 end	
		} else {
			set maara $c($j,lkm)
			for {set k 1} {$k <= $maara} {incr k 1} {
				set ehto($j-$k) 0
			}
		}
	}
	foreach j {nimi kuvaus yhteydet} {
		$f.fPe.$j.en$j delete 0 end	
	}
	focus $f.frRn.enRn
	set tallennettu(r) 0
}

proc asetaTekstit {} {
   global t  
   	lappend t(asetukset) 		{Asetukset} 		{Settings}
   	lappend t(avaa) 			{Avaa} 			{Open}
   	lappend t(avaaeditoriin) 	{Avaa editoriin} 		{Open in editor}
   	lappend t(avaaohje) 		{Avaa ohje} 		{Open help}
   	lappend t(avaaraportti) 	{Avaa raportti} 		{Open report}
   	lappend t(avaatiedosto) 	{Avaa tiedosto} 		{Open file}
   	lappend t(avaavaatimusikkuna) {Avaa vaatimusikkuna} 	{Open requirement window}
   	lappend t(avaavm)   		{Vaatimusmrittelyn avaaminen} {Open requirement specification}
   	lappend t(ei) 			{Ei} 				{No}
   	lappend t(editori)		{Editori} 			{Editor}
	lappend t(idea) 			{Idea} 			{Idea}
   	lappend t(idtunnus) 		{ID-tunnus} 		{ID-label}
	lappend t(joy) 			{Joensuun yliopisto} 	{University of Joensuu}
  	lappend t(kaikki) 		{Kaikki} 			{All}
	lappend t(kaikkivaatimukset) 	{Kaikki vaatimukset:} 	{All requirements:}
   	lappend t(kieli) 			{Kieli} 			{Language}
   	lappend t(kuvaus) 		{Kuvaus} 			{Description}
   	lappend t(kylla) 			{Kyll} 			{Yes}
   	lappend t(lataaoletukset) 	{Aseta oletusarvot} 	{Set default values}
   	lappend t(lisaa) 			{Lis} 			{Add}
   	lappend t(lisaayhteys) 		{Lis yhteys >>} 	{Add connection >>}
   	lappend t(lopeta) 		{Lopeta} 			{Exit}
   	lappend t(luo) 			{Luo}			 	{Create}
   	lappend t(muokkaa) 		{Muokkaa} 			{Edit}
   	lappend t(muokkaayhteyksia) 	{Muokkaa yhteyksi} 	{Edit connections}
   	lappend t(muutajarjestysta) 	{Muuta jrjestyst} 	{Change order}
   	lappend t(muutasijaintia) 	{Muuta sijaintia} 	{Change location}
   	lappend t(naytaperusteet)	{Nyt perusteet} 	{Show explanations}
   	lappend t(nimi) 			{Nimi} 			{Name}
   	lappend t(ohje) 			{Ohje} 			{Help}
   	lappend t(oletuseditori) 	{Oletuseditori} 		{Default editor}
   	lappend t(oletusselain) 	{Oletusselain} 		{Default browser}
   	lappend t(paivays) 		{Pivys} 			{Date}
   	lappend t(perusteet) 		{Perusteet} 		{Explanations}
   	lappend t(peruuta) 		{Peruuta} 			{Cancel}
   	lappend t(poista) 		{Poista} 			{Remove}
   	lappend t(poistayhteys) 	{<< Poista yhteys} 	{<< Remove connection}
  	lappend t(raportinesitystapa) {Raportin esitystapa} 	{Format of the report}
   	lappend t(raportinluominen) 	{Raportin luominen} 	{Create report}
   	lappend t(raportinnimi) 	{Raportin nimi} 		{Report's name}
   	lappend t(raportti) 		{Raportti} 			{Report}
  	lappend t(raporttiluettelolla) {Otsikot ja vaatimukset} {Titles and requirements}
  	lappend t(raporttiluettelotta) {Vaatimusten luettelo}   {List of requirements}
   	lappend t(selaa) 			{Selaa} 			{Browse}
    	lappend t(selain) 		{Selain} 			{Browser}
  	lappend t(sulje) 			{Sulje} 			{Close}
	lappend t(siirra) 		{Siirr} 			{Move}
   	lappend t(tallenna) 		{Tallenna} 			{Save}
	lappend t(tallennaraportti) 	{Tallenna raportti} 	{Save report}
   	lappend t(tallennatiedostoon) {Tallenna tiedostoon} 	{Save to file}
    	lappend t(tekija) 		{Tekij} 			{Author}
	lappend t(tiedosto)		{Tiedosto} 			{File}
	lappend t(tietoja) 		{Tietoja ohjelmasta} 	{About Sfrm}
	lappend t(tkt) 			{Tietojenksittelytieteen laitos} 	{Department of Computer Science}
	lappend t(toteutus) 		{Toteutus} 			{Implementation}
	lappend t(tyhjennatiedot) 	{Tyhjenn tiedot} 	{Clear selections}
	lappend t(vaatimus) 		{Vaatimus} 			{Requirement}
   	lappend t(valinta) 		{Valinta} 			{Choice}
  	lappend t(valintaehto) 		{Valintaehto} 		{Selection condition}
  	lappend t(valintaperuste) 	{Valintaperuste} 		{Selection basis}
   	lappend t(valitse) 		{Valitse} 			{Select}
	lappend t(viimeiseksi) 		{-- viimeiseksi --} 	{-- last --}
	lappend t(yhteysvaatimuksiin) {Yhteys vaatimuksiin:} 	{Connection to requirements:}
   	lappend t(yhteydet) 		{Yhteydet} 			{Connections}
   	lappend t(yleistiedot) 		{Yleistiedot} 		{General data}

   	lappend t(asetuksettallennettiintiedostoon) 	{Asetukset tallennettiin tiedostoon } 	{Settings saved to the file }
   	lappend t(haluatkoavataraportinselaimeen) 	{Haluatko avata raportin selaimeen?} 	{Open report in browser?}
   	lappend t(otsikonallaonvainyksivaatimus) 		{Otsikon alla on vain yksi vaatimus!} 	{Under the selected title is only one requirement!}
   	lappend t(raportinmuodostamisperusteet) 		{Raportin muodostamisperusteet} 		{Basis for creating report}
   	lappend t(vaatimuksestaesitettavattiedot) 	{Valituista vaatimuksista esitettvt tiedot} 		{Data to be included in report}
   	lappend t(raporttiikkunansulkeminen) 		{Raportti-ikkunan sulkeminen}			{Closing create report window}
   	lappend t(raporttiontallennettu) 			{Raportti on tallennettu nimell} 		{Report is saved as}
   	lappend t(vaatimuksenlisaaminen) 			{Vaatimuksen lisminen} 			{Add requirement}
   	lappend t(vaatimuksenmuokkaaminen) 			{Vaatimuksen muokkaaminen} 			{Edit requirement}
    	lappend t(vaatimuksenpoistaminen) 			{Vaatimuksen poistaminen} 			{Remove requirement}
  	lappend t(vaatimuksensijainninmuuttaminen) 	{Vaatimuksen sijainnin muuttaminen} 		{Change requirement's location}
   	lappend t(vaatimuksentallentaminen) 		{Vaatimuksen tallentaminen} 			{Save requirement}
   	lappend t(vaatimuksettallennettiintiedostoon) 	{Vaatimukset tallennettiin tiedostoon } 	{Requirements saved to the file }
   	lappend t(vaatimusikkunansulkeminen) 		{Vaatimusikkunan sulkeminen} 			{Closing requirement window}
   	lappend t(vaatimusmaarittelynsulkeminen) 		{Vaatimusmrittelyn sulkeminen} 		{Closing requirement specification}
   	lappend t(vaatimustenjarjestyksenmuuttaminen) 	{Vaatimusten jrjestyksen muuttaminen} 	{Change requirement's order}
  	lappend t(vaatimustenvalintaperusteet) 		{Vaatimusten valintaperusteet} 		{Basis to select requirements}
   	lappend t(yhteyksienmuokkausikkunansulkeminen) 	{Yhteyksien muokkausikkunan sulkeminen} 	{Closing window 'Edit connections'}
   	lappend t(yleistiedotikkunansulkeminen) 		{Yleistiedot ikkunan sulkeminen} 		{Closing general data window}
   	lappend t(yleistiedottallennettiintiedostoon) 	{Yleistiedot tallennettiin tiedostoon } 	{General data saved to file }

   	lappend t(alkunumeroaeiole) \
            {Vaatimusten alkunumeroa ei ole annettu! Tarkista oletusasetustiedosto 'kyttj.rms'.} \
            {Starting number of requirements is not given. Check default settings file 'user.rms'.}
   	lappend t(avaavmhuomautus1) \
            {Virhe tiedoston lukemisessa! Tarkista, ett valitsemasi tiedosto on vaatimusmrittelyn hierarkiatiedosto. Virheteksti:} \
            {Error reading file! Check, that the file you selected, is sfrm-hierarchy file. Errortext:}
   	lappend t(avaavmhuomautus2) \
            {Virhe tiedoston lukemisessa! Tarkista, ett tiedosto on samassa hakemistossa vaatimusmrittelyn hierarkiatiedoston kanssa \
			ja ett se on vaatimusluokitustiedosto.} \
            {Error reading file! Check, that the file you have selected, is in same directory as sfrm-hierarchy \
			file and that it is sfrm-classification file.}
   	lappend t(avaavmhuomautus3) {Vaatimusluokitustiedostoa ei lydy!} {Sfrm-classification file is missing!}
   	lappend t(avaavmhuomautus4) \
            {Virhe tiedoston lukemisessa! Tarkista, ett tiedosto on vaatimusten tallennustiedosto.} \
            {Error reading file! Check, that the file is sfrm-data file.}
   	lappend t(avaavmhuomautus5) \
            {Vaatimustiedostoa ei lydy tai olet aloittamassa uutta vaatimusmrittely!} \
            {Sfrm-data file is missing or you are starting a new requirement specification!}
   	lappend t(avaavmhuomautus6) \
            {Virhe tiedoston lukemisessa! Tarkista, ett tiedosto on yleistiedot tiedosto.} \
            {Error reading file! Check, that the file is sfrm-general data file.}
   	lappend t(avaavmhuomautus7) \
            {Tiedostoa ei lydy tai tietoja ei ole mritetty! Voit mritt tiedot valitsemalla 'Yleistiedot - Muokkaa...'} \
            {File is missing or general data is not specified. You can specify data by selecting 'General data - Edit...'}
   	lappend t(annaeditori) \
		{Valitse 'Selaa...' ja paikanna haluamasi editori valintaikkunassa:} \
		{Click 'Browse...' and use dialogbox to locate the texteditor you want:}
   	lappend t(annaselain) \
		{Valitse 'Selaa...' ja paikanna haluamasi selain valintaikkunassa:} \
		{Click 'Browse...' and use dialogbox to locate the web browser you want:}
   	lappend t(haluatkotallentaavaatimuksettiedostoon) \
            {Tehtyj muutoksia ei ole tallennettu tiedostoon! \
			Haluatko tallentaa vaatimukset tiedostoon ennen vaatimusmrittelyn sulkemista?} \
		{Changes are not saved! Do you want to save requirements to the file before closing the requirement specification?}
   	lappend t(kaikkiaavoimiaeioletallennettu) \
            {Kaikkien avoimien vaatimusten tietoja ei ole tallennettu! Haluatko tallentaa kaikki muutetut tiedot?} \
            {All changes are not saved! Do you want to save all changed data?}
   	lappend t(lataaoletuksethuomautus) \
            {Virhe tiedoston lukemisessa! Tarkista, ett tiedosto on kyttjn oletusasetustiedosto ja ett \
			se sijaitsee kynnistyshakemistossa tai samassa hakemistossa kuin sovellustiedosto sfrm.tcl.} \
            {Error reading file! Check, that the file you have selected, is in the starting directory or in the same directory as sfrm.tcl \
			file and that it is user's sfrm-defaults file.}
   	lappend t(loppunumeroaeiole) \
            {Vaatimusten loppunumeroa ei ole annettu! Tarkista oletusasetustiedosto 'kyttj.rms'.} \
            {Ending number of requirements is not given. Check default settings file 'user.rms'.}
   	lappend t(numeroitaeioleannettu) \
            {Kyttjlle ei ole mritelty vaatimusnumeroita avattuun vaatimusmrittelyyn! Tarkista oletusasetustiedosto 'kyttj.rms'.} \
            {User specific requirements id-numbers for this RM is not given. Check default settings file 'user.rms'.}
   	lappend t(oletuseditoriaeiole) \
            {Oletuseditoria ei ole mritetty! Aseta editori valitsemalla 'Asetukset - Oletuseditori...'.} \
            {Default editor is not defined! Set editor by selectig 'Settings - Default editor...'.}
   	lappend t(oletusselaintaeiole) \
            {Oletusselainta ei ole mritetty! Aseta selain valitsemalla 'Asetukset - Oletusselain...'.} \
            {Default browser is not defined! Set browser by selecting 'Settings - Default browser...'.}
  	lappend t(poistetaankovaatimus) \
            {Poistetaanko vaatimus? Jos valitset 'Poista', poistat vaatimuksen pysyvsti. \
		Mys vaatimukseen mritetyt yhteydet poistetaan. Valitsemalla 'Peruuta' palaat ohjelmaan vaatimusta poistamatta.} \
            {Remove requirement? If you select 'Remove', requirement and connections to it will be removed. \
		If you select 'Cancel', you will return to the application without removing the requirement.}
   	lappend t(tallennustaeisuoritettu) \
            {Vaatimusmrittely ei ole avattuna! Tallennusta ei suoritettu.} \
            {No open requirement specification! Saving to the file is not done.}
   	lappend t(tarkistavalinta1) \
            {Otsikkoa, jonka alle vaatimus listn, ei ole valittu! Valitse ensin haluamasi alimman tason otsikko.} \
            {Title is not selected! Select title again.}
   	lappend t(tarkistavalinta2) \
            {Luettelossa ei ole valittuna alimman tason otsikko! Valitse ensin haluamasi alimman tason otsikko.} \
            {Lowest level title not selected in directory! Select first the lowest level title you want.}
   	lappend t(tarkistavalinta3) \
            {Luettelossa on valittuna vaatimus! Valitse ensin haluamasi alimman tason otsikko tai avaa vaatimus valitsemalla 'Vaatimus-Muokkaa'.} \
            {Requirement selected in directory! Select first lowest level title you want.}
   	lappend t(tarkistavalinta4) \
            {Muokattavaa vaatimusta ei ole valittu! Valitse ensin haluamasi vaatimus luettelosta.} \
            {Requirement is not selected! Select first the requirement you want to edit.}
   	lappend t(tarkistavalinta5) \
            {Luettelossa on valittuna otsikko! Valitse ensin haluamasi vaatimus luettelosta tai lis uusi vaatimus valitsemalla 'Vaatimus-Lis'.} \
            {Title selected in directory! Select first requirement you want to edit or add new by selecting 'Requirement - Add...'.}
   	lappend t(tarkistavalinta6) \
            {Siirrettv vaatimusta ei ole valittu! Valitse ensin haluamasi vaatimus luettelosta.} \
            {Requirement is not selected! Select first the requirement you want to move.}
   	lappend t(tarkistavalinta7) \
            {Luettelossa on valittuna otsikko! Valitse ensin haluamasi vaatimus luettelosta.} \
            {Title selected in directory! Select first the requirement you want to move.}
   	lappend t(tietojaeioletallennettu) \
            {Tietoja ei ole tallennettu. Haluatko tallentaa ennen ikkunan sulkemista?} \
            {Changes are not saved! Do you want to save before closing the window?}
   	lappend t(uudellevaatimukselleeioleannettunimea) \
            {Uudelle vaatimukselle ei ole annettu nime! Anna nimi ja paina vaatimuksen 'Tallenna' -painiketta uudelleen.} \
            {New requirement has no name! Give name and select 'Save' -button in requirement window again.}
   	lappend t(uusienvaatimustentietojaeitallennettu) \
            {Uusien tallentamattomien vaatimusten tietoja ei tallennettu tiedostoon! Tallenna ne ensin vaatimuksen 'Tallenna' -painikkeella ja \
			valitse sen jlkeen 'Tiedosto - Tallenna' uudelleen.} \
            {Data of new unsaved requirements is not saved to the file! Save them first by selecting 'Save' -button \
			in requirement window and after that select 'File - Save' again.}
   	lappend t(vaatimusmaarittelyaeioleavattu) \
            {Vaatimusmrittely ei ole avattu! Avaa ensin haluamasi vaatimusmrittely valitsemalla 'Tiedosto - Avaa...'.} \
            {Requirement specification is not opened! Open first the requirement specification you want by selecting 'File - Open...'.}
   	lappend t(vaatimusonjoolemassa) \
            {- niminen vaatimus on jo olemassa! Anna vaatimukselle uusi nimi ja paina vaatimuksen 'Tallenna' -painiketta uudelleen.} \
            {- named requirement already exists! Give new name and select in requirement window 'Save' -button again.}
   	lappend t(valitseotsikko) \
            {Valitse otsikko, jonka alle haluat siirt vaatimuksen:} \
            {Select the title, under that you want to move requirement:}
   	lappend t(valitsepaikka) \
            {Valitse vaatimus, jonka eteen haluat siirt vaatimuksen:} \
            {Select the requirement, before that you want to move requirement:}
   	lappend t(valitsetallentamisenjalkeenlopetauudelleen) \
            {Valitse vaatimuksen tallentamisen jlkeen 'Tiedosto - Lopeta' uudelleen.} \
            {After you have saved requirement select 'File - Exit' again.}
   	lappend t(valitsetallentamisenjalkeensuljeuudelleen) \
            {Valitse vaatimuksen tallentamisen jlkeen 'Tiedosto - Sulje' uudelleen.} \
            {After you have saved requirement select 'File - Close' again.}
   	lappend t(valitsetallentamisenjalkeentallennauudelleen) \
            {Valitse vaatimuksen tallentamisen jlkeen 'Tiedosto - Tallenna' uudelleen.} \
            {After you have saved requirement select 'File - Save' again.}
   	lappend t(virheavattaessaeditoria) \
            {Virhe editoria avattaessa! Tarkista, ett oletuseditori on mritetty oikein. Errortext:} \
            {Error while opening editor! Check, that default editor is correctly set. Errortext:}
   	lappend t(virheavattaessaohjetta)	\
		{Virhe ohjetta avattaessa! Tarkista, ett oletusselain on mritetty oikein. Errortext:} \
		{Error while opening help! Check, that default browser is correctly set. Errortext:}
   	lappend t(virheavattaessaraporttia)	\
		{Virhe raporttia avattaessa! Tarkista, ett oletusselain on mritetty oikein. Errortext:} \
		{Error while opening report! Check, that default browser is correctly set. Errortext:}
  	lappend t(numerotloppui) \
            {Kyttjlle oletusasetustiedostossa varatut vaatimusnumerot loppuivat!} \
            {No ID-numbers left (see the settings file)!}
  	lappend t(numerotvirheellisia) \
            {Vaatimusta ei voi list! Virhe kyttjn oletusasetustiedostossa alku- ja loppunumeroiden mrittelyss! Tarkista tiedoston sislt.} \
            {Can't add the requirement! Error in default ID-numbers. (see the settings file)!}

  	lappend t(tarkistaoletusnumerot) \
            "Virhe luettaessa oletusasetustiedoston alku- ja loppunumeroita! Tarkista tiedoston sislt." \
            {Error while reading default ID-numbers! Check the contents of the file.}
}

proc lataaKielitiedot {kieli} {
   global k t
   foreach teksti [array names t] {
      set k($teksti) [lindex $t($teksti) $kieli]
   }
}

proc vaihdaKieli {kieli} {
	global c k v idTun tietoLkm
	vaihdaKohdistin watch
	lataaKielitiedot $kieli

	.menu entryconfigure 0 -label "$k(tiedosto)"
	.menu entryconfigure 1 -label "$k(vaatimus)"
	.menu entryconfigure 2 -label "$k(asetukset)"
	.menu entryconfigure 3 -label "$k(yleistiedot)"
	.menu entryconfigure 4 -label "$k(ohje)"

	.menu.tiedosto entryconfigure 1 -label "$k(avaa)..."
	.menu.tiedosto entryconfigure 2 -label "$k(tallenna)"
	.menu.tiedosto entryconfigure 4 -label "$k(raportti)"
	.menu.tiedosto entryconfigure 6 -label "$k(sulje)"
	.menu.tiedosto entryconfigure 7 -label "$k(lopeta)"

	.menu.vaatimus entryconfigure 1 -label "$k(lisaa)..."
	.menu.vaatimus entryconfigure 2 -label "$k(muokkaa)..."
	.menu.vaatimus entryconfigure 3 -label "$k(muutajarjestysta)..."
	.menu.vaatimus entryconfigure 4 -label "$k(muutasijaintia)..."

	.menu.asetukset entryconfigure 1 -label "$k(oletuseditori)..."
	.menu.asetukset entryconfigure 2 -label "$k(oletusselain)..."
	.menu.asetukset entryconfigure 4 -label "$k(kieli)"

	.menu.yleistiedot entryconfigure 1 -label "$k(muokkaa)..."

	.menu.ohje entryconfigure 1 -label "$k(ohje)"
	.menu.ohje entryconfigure 3 -label "$k(tietoja)"

	.menu.tiedosto.raportti entryconfigure 0 -label "$k(luo)..."
	.menu.tiedosto.raportti entryconfigure 1 -label "$k(avaa)..."
	foreach w [winfo children .] {
      	switch [winfo class $w] {
      	   "Vaatimusikkuna" {
			set alku [expr [string first "-" $w]+ 1]
			set idTun [string range $w $alku end]
	            wm title $w "$k(vaatimus): $v($idTun,nimi)"
			$w.fb.poista configure -text "$k(poista)"
			$w.fb.tallenna configure -text "$k(tallenna)"
			$w.fb.sulje configure -text "$k(sulje)"
			$w.frKanvaasi.ca.frPo.frId.lbId configure -text "$k(idtunnus):"  
			$w.frKanvaasi.ca.frPo.frNi.lbNi configure -text "$k(nimi):"
			$w.frKanvaasi.ca.frPo.frKu.a.lbKu configure -text "$k(kuvaus):"
			$w.frKanvaasi.ca.frPo.frKu.a.muokkaa configure -text "$k(avaaeditoriin)"
			$w.frKanvaasi.ca.frPo.frYh.a.lbYh configure -text "$k(yhteydet):"
			$w.frKanvaasi.ca.frPo.frYh.a.buLisaa configure -text "$k(muokkaa)"
			for {set i 0} {$i < $tietoLkm} {incr i 1} {
			   switch $c($i,tyyppi) {		
				<tekstiP>  {
					$w.frKanvaasi.ca.frPo.fr$i.a.muokkaa \
						configure -text "$k(avaaeditoriin)"
				} 	
				<luokitus> { 
					$w.frKanvaasi.ca.frPo.fr$i.a.bu$i \
						configure -text "$k(naytaperusteet)"
				} 
			   }
			}
		   }
	   	   "Perusteetikkuna" {
			set alku [expr [string first "-" $w]+ 1]
			set i [string range $w $alku end]
			wm title $w "$k(perusteet): $c($i,nimi)"
			$w.f1.sulje configure -text "$k(sulje)"
		   }
		   "Raporttikkuna" {
			wm title $w "$k(raportinluominen)"
			$w.fb.tyhjenna configure -text "$k(tyhjennatiedot)" 
			$w.fb.luo configure -text "$k(luo)" 
			$w.fb.sulje configure -text "$k(sulje)" 
			set f $w.frKanvaasi.ca.frPo 
			$f.frRn.lbRn configure -text "$k(raportinnimi):" 
			$f.frYt.a.lbYt configure -text "$k(yleistiedot):" 
			$f.fEt.a.lb configure -text "$k(raportinesitystapa):" 
			$f.fEt.b.b1 configure -text "$k(raporttiluettelolla)"   
			$f.fEt.b.b2 configure -text "$k(raporttiluettelotta)"  
			$f.fPe.a.lb configure -text "$k(vaatimustenvalintaperusteet):" 
			$f.fPe.b.lb1 configure -text "$k(valintaperuste):" 
			$f.fPe.b.lb2 configure -text "$k(valintaehto):" 
			$f.fPe.all.cbAll configure -text "$k(kaikki)" 
			$f.fPe.nimi.cbnimi configure -text "$k(nimi)"
			$f.fPe.kuvaus.cbkuvaus configure -text "$k(kuvaus)"  
			$f.fPe.yhteydet.cbyhteydet configure -text "$k(yhteydet)" 
			$f.fVa.a.lb configure -text "$k(vaatimuksestaesitettavattiedot):"
			$f.fVa.cb.cbKaikki configure -text "$k(kaikki)" 
			$f.fVa.cb.cbNimi configure -text "$k(nimi)" 
			$f.fVa.cb.cbKuvaus configure -text "$k(kuvaus)" 
 			$f.fVa.cb.cbYhteydet configure -text "$k(yhteydet)"
		   }			
		}
	}
   	vaihdaKohdistin oletus
}

proc haeIdTunnusPaikka {paikka} {
	global v vaatimukset

	foreach i $vaatimukset {
		if {[string compare $paikka $v($i,solmu)] == 0} {
			set idTun $v($i,id) 
			break
		}
	}
	return $idTun
}

proc haeOtsikonSolmu {win nimi node} {
    	global hierInfo 
	global v

    	set var $hierInfo($win-data)
    	upvar #0 $var data
	set solmu ""
	foreach subnode $data($node-children) {
		if {$data($subnode-label) == $nimi} {
			set solmu $subnode
			break
		} else {
			set solmu [haeOtsikonSolmu $win $nimi $subnode]
		}
		if {$solmu != ""} {break}
	}
	if {$solmu != ""} {return $solmu}
}

proc haeVaatimuksetListaan {win} {
    	global hierInfo v alasolmut vaatimukset

    	set var $hierInfo($win-data)
    	upvar #0 $var data
	set infolista ""
	set apulista ""
	foreach i $vaatimukset {
		if {$v($i,nimi) != "" } {
			set isasolmu "$v($i,paikka)"
			set alasolmut($isasolmu) ""
		}
	}
	foreach i $vaatimukset {
		if {$v($i,nimi) != "" } {
			set isasolmu "$v($i,paikka)"
			if {[llength $alasolmut($isasolmu)] == 0} {
				lappend alasolmut($isasolmu) $v($i,id)
				lappend infolista $isasolmu 
			} else {
				set apulista ""
				set laskuri 0
				set jolisatty 0
				set pituus [llength $alasolmut($isasolmu)]
				foreach x $alasolmut($isasolmu) {
					if {$v($i,jnro) < $v($x,jnro) && !$jolisatty} {
						lappend apulista $v($i,id)
						set jolisatty 1
					}
					lappend apulista $v($x,id)
					incr laskuri
					if {$laskuri == $pituus && !$jolisatty} {
						lappend apulista $v($i,id)
					}
				}
				set alasolmut($isasolmu) $apulista
			}
		}
	}
	foreach k $infolista {
		foreach id $alasolmut($k) {
			lappend info($k) "\"$v($id,nimi)\" \{\}"
		}
	}
	foreach k $infolista {
		set otsikko "$data($k-label)"
		hierlist_data_add $var $k $otsikko "$info($k)"
		hierlist_redraw $win 
		update
		wm deiconify .
	}
}

proc laajennaSolmu {solmu alkuosa} {

	set loppuosa [string range $solmu [expr [string length $alkuosa] + 1] end]
	set x [string first "-" $loppuosa]
	if {$x != -1} {
		if {[string length $loppuosa] > 0} {
			set nro [string range $loppuosa 0 [expr $x -1]]
			set isasolmu "$alkuosa-$nro"
		} else {
			set isasolmu $solmu		
		}
		hierlist_expand .list "$isasolmu"
		hierlist_select .list "$solmu"
		laajennaSolmu $solmu $isasolmu 
		.list.hbox see [.list.hbox index $solmu.first]
	}
}
	
proc lisaaVaatimusListaan {win idTun node} {
    	global hierInfo v alasolmut

    	set var $hierInfo($win-data)
    	upvar #0 $var data
	set info ""
	set otsikko "$data($node-label)"
	set laskuri 1
	foreach x $alasolmut($node) {
		lappend info "\"$v($x,nimi)\" \{\}"
		set v($x,jnro) $laskuri
		incr laskuri
	}
	hierlist_data_add $var $node $otsikko $info
	hierlist_redraw $win
	update
	wm deiconify .
	hierlist_expand_all $win
	laajennaSolmu "$v($idTun,solmu)" "root"
}

proc lueHierarkiaListaan {} {

	set win .list.hbox 
	$win mark set last end
	set jatketaan 1
	set i 1
	set apu ""
	while {$jatketaan != 0} {
		if {[$win compare $i.end < last] == 1} {
			set rivi [string trim [$win get $i.0 $i.end]]
			if {[string length $rivi] != 0} {
				lappend apu "$rivi"
			}
			incr i 
		} else {
			set jatketaan 0
		}
	}
	return $apu	
}

proc lueHierarkiaTaulukko {} {
	global h

	set lkm [expr [array size h] / 2]
	set lista ""
	set h([expr $lkm+1],taso) 1
	set x 1
	while {$x <= $lkm} {
		set n $h($x,nimi)
		set t $h($x,taso)
		set st $h([expr $x+1],taso)
		set ero [expr $st-$t]
		append lista "\{\"$n\""
		if {$ero > 0} {
			for {set y 1} {$y <= $ero} {incr y 1} {
				append lista " \{"
			}
		} else {
			append lista " {}"
			for {set y 1} {$y <= ([expr [expr -2 * $ero] + 1])} {incr y 1} {
				append lista "\}"
			}
			append lista " "
		}
		incr x
	}
    	return $lista
}


proc muutaJarjestys {solmu idTunnus tagi} {
	global v alasolmut ji k tallennettu

	set valittu [$ji.fv.k.t get $tagi.0 $tagi.end]
	set viimeiseksi $k(viimeiseksi)
	if {$valittu != "$viimeiseksi"} {
		set paikka [haeIdTunnusNimi $valittu]
	} else {
		set paikka $valittu 
	}
	if {$paikka != $idTunnus} {
		set apulista ""
		if {$paikka == "$viimeiseksi"} {
			foreach x $alasolmut($solmu) {
				if {$idTunnus != $x} {
					lappend apulista $x
				}
			}
			lappend apulista $idTunnus			
		} else {
			foreach x $alasolmut($solmu) {
				if {$paikka == $x} {
					lappend apulista $idTunnus
					lappend apulista $x
				} else {
					if {$idTunnus != $x} {
						lappend apulista $x					
					}
				}
			}
		}
		set alasolmut($solmu) $apulista
		set laskuri 1
		foreach x $alasolmut($solmu) { 
			set v($x,jnro) $laskuri
			incr laskuri	
		}
		haeVaatimuksetListaan .list
		hierlist_expand_all .list
		laajennaSolmu "$v($idTunnus,solmu)" "root"
		set tallennettu(tiedostoon) 0
	}
	suljeXiIkkuna $ji
}

proc onkoAlinOtsikko {win node} {
	global hierInfo

	set var $hierInfo($win-data)
	upvar #0 $var data
	set found 0
	set num 0
	if {[onkoOtsikko $data($node-label)]} { 
		set found 1
      	foreach subnode $data($node-children) {
            	incr num
	  		set data($subnode-label) \
		     		$data($subnode-label)
            	if {[onkoOtsikko $data($subnode-label)]} {
				set found 0
				break
			} 
		}
	}
	return $found
}

proc onkoOtsikko {label} {
	global h

	set lkm [expr [array size h] / 2]
	set onOtsikko 0
	for {set i 1} {$i <= $lkm} {incr i} {
		if {[string compare $label $h($i,nimi)] == 0} {
			set onOtsikko 1
			break
		}
	}
	return $onOtsikko
}

proc paivitaJarjestysLista {idTunnus} {
	global alasolmut v 

	set laskuri 1
	set apulista ""
	set solmu $v($idTunnus,paikka)
	foreach x $alasolmut($solmu) { 
		if {$idTunnus != $x} {
			lappend apulista $x
			set v($x,jnro) $laskuri 
			incr laskuri	
		}
	}
	set alasolmut($solmu) $apulista
}

proc poistaVaatimusLuettelosta {win idTunnus} {
    	global hierInfo v

    	set var $hierInfo($win-data)
    	upvar #0 $var data
	paivitaJarjestysLista $idTunnus
	set isasolmu "$v($idTunnus,paikka)"
	set infolista ""	
	foreach k $data($isasolmu-children) {
		if {$k != $v($idTunnus,solmu)} {
			set idTun [haeIdTunnusPaikka $k]
			lappend infolista "\"$v($idTun,nimi)\" \{\}" 
		}
	}
	set info($isasolmu) ""
	set otsikko "$data($isasolmu-label)"
	hierlist_data_add $var $isasolmu $otsikko "$infolista"
	hierlist_redraw $win 
}

proc suoritaValinta {ji tagi toimenpide} {
	global edvalinta valittu 

	set tbox $ji.fv.k.t
	if {$edvalinta != 0} {
		$tbox tag configure $edvalinta -background {}
	}
	switch $toimenpide {
		"jarjesta" {$tbox tag configure $tagi -background pink}				
		"siirra"   {
			set otsikko [$tbox get $tagi.0 $tagi.end] 
			set otsikonsolmu [haeOtsikonSolmu .list $otsikko "root"]
		 	set onAlinOtsikko [onkoAlinOtsikko .list $otsikonsolmu]
			if {$onAlinOtsikko} {
				$tbox tag configure $tagi -background LightGreen
			} else {
				$tbox tag configure $tagi -background LightGray
			}
		}
	}
	set edvalinta $tagi
	set valittu $tagi
	$ji.fb.siirra configure -state normal
}

proc siirraJarjestys {alkusolmu idTunnus tagi} {
	global alasolmut ji k v tallennettu

	set win .list
	set valittu [string trim [$ji.fv.k.t get $tagi.0 $tagi.end]]
	set loppusolmu [haeOtsikonSolmu $win $valittu "root"]
	set otsikko "$k(vaatimuksensijainninmuuttaminen)"
	set huomautus "$k(tarkistavalinta2)"
 	set onAlinOtsikko [onkoAlinOtsikko $win $loppusolmu]
	if {$alkusolmu != $loppusolmu} {  
		if {!$onAlinOtsikko} {
			tk_dialog .dialog_rl $otsikko $huomautus info 0 OK
		} else {
			poistaVaatimusLuettelosta $win $idTunnus
			set v($idTunnus,paikka) $loppusolmu
			lappend alasolmut($loppusolmu) $idTunnus
			lisaaVaatimusListaan $win $idTunnus "$v($idTunnus,paikka)"
			set tallennettu(tiedostoon) 0
			suljeXiIkkuna $ji
		}
	}
}

proc tallennaVaatimuksenSolmu {sublabel subnode} {
	global v vaatimukset

	foreach i $vaatimukset {
		if {[string compare $sublabel $v($i,nimi)] == 0} {
			set v($i,solmu) $subnode
		}
	}
}

proc tarkistaValintaJaAvaa { } {
	global hierInfo k	
	
	set win .list
	set var $hierInfo($win-data)
	upvar #0 $var data
	set valittu [hierlist_selected $win] 
	set otsikko "$k(vaatimuksenmuokkaaminen)"
	set huomautus1 "$k(tarkistavalinta4)"
	set huomautus2 "$k(tarkistavalinta5)"
	if {[string length $valittu] == 0} {
		after idle {.dialog_tvja1.msg configure -wraplength 10c}
		tk_dialog .dialog_tvja1 $otsikko $huomautus1 info 0 OK
	} elseif {[onkoOtsikko $data($valittu-label)]} {
		after idle {.dialog_tvja2.msg configure -wraplength 10c}
		tk_dialog .dialog_tvja2 $otsikko $huomautus2 info 0 OK
	} else {
		avaaVaatimusikkuna [haeIdTunnusPaikka "$valittu"]
	}
}

proc tarkistaValintaJaJarjesta {toimenpide} {
	global hierInfo k	
	
	set win .list
	set var $hierInfo($win-data)
	upvar #0 $var data
	set valittu [hierlist_selected $win]
	set otsikko "$k(muutajarjestysta)"
	set huomautus1 "$k(tarkistavalinta6)"
	set huomautus2 "$k(tarkistavalinta7)"
	if {[string length $valittu] == 0} {
		after idle {.dialog_tvja1.msg configure -wraplength 10c}
		tk_dialog .dialog_tvja1 $otsikko $huomautus1 info 0 OK
	} elseif {[onkoOtsikko $data($valittu-label)]} {
		after idle {.dialog_tvja2.msg configure -wraplength 10c}
		tk_dialog .dialog_tvja2 $otsikko $huomautus2 info 0 OK
	} else {
		avaaJarjestysIkkuna [haeIdTunnusPaikka "$valittu"] $toimenpide
	}
}

proc tarkistaValintaJaLisaa { } {
	global hierInfo k	
	
	set win .list
	set var $hierInfo($win-data)
	upvar #0 $var data
	set valittu [hierlist_selected $win]
	set otsikko "$k(vaatimuksenlisaaminen)"
	set huomautus1 "$k(tarkistavalinta1)"
	set huomautus2 "$k(tarkistavalinta2)"
	set huomautus3 "$k(tarkistavalinta3)"
	if {[string length $valittu] == 0} {
		after idle {.dialog_tvjl1.msg configure -wraplength 10c}
		tk_dialog .dialog_tvjl1 $otsikko $huomautus1 info 0 OK
	} else {
		set onOtsikko [onkoOtsikko $data($valittu-label)]
		set onAlinOtsikko [onkoAlinOtsikko .list $valittu] 
		if {$onOtsikko && !$onAlinOtsikko} {
			after idle {.dialog_tvjl2.msg configure -wraplength 10c}
			tk_dialog .dialog_tvjl2 $otsikko $huomautus2 info 0 OK
		} elseif {!$onOtsikko} {
			after idle {.dialog_tvjl3.msg configure -wraplength 10c}
			tk_dialog .dialog_tvjl3 $otsikko $huomautus3 info 0 OK
		} else {
			lisaaVaatimus $valittu
		}
	}	
}

proc tulostaListaJIkkunaan {tbox lista suorita toimenpide} { 
	global v idtun ji

	set laskuri 1
	foreach i $lista {
		set tagi $laskuri
		$tbox mark set pos "$laskuri.0"
		$tbox insert pos "$i\n" "$tagi"
		$tbox tag bind $tagi <ButtonPress-1> "suoritaValinta $ji $tagi $toimenpide"
		$tbox tag bind $tagi <Double-Button-1> {$suorita $solmu $idTun $valittu}
		incr laskuri
	}
	$tbox configure -state disabled
}

proc valitseSolmu {win subnode} {
	global paikka 
	hierlist_select $win $subnode 
	set paikka $subnode
}

option add *Hierlist.activeColor LightGray widgetDefault
option add *Hierlist.activeAlinOtColor LightGreen widgetDefault
option add *Hierlist.activeVaColor pink widgetDefault
option add *Hierlist.indent 15 widgetDefault
option add *Hierlist.hbox.background white widgetDefault
option add *Hierlist.hbox.width 40 widgetDefault
option add *Hierlist.hbox.height 30 widgetDefault
option add *Hierlist.hbox.cursor arrow widgetDefault
option add *Yhteydet.teksti.cursor arrow widgetDefault
option add *Jarjestysikkuna.fv.k.t.cursor arrow widgetDefault
option add *Entry.background white startupFile
option add *Hierlist.hbox.font \
    -*-lucida-medium-r-normal-sans-*-120-* widgetDefault

proc hierlist_create {win {cmd ""}} {
    global hierInfo

    set hierInfo($win-pending) ""
    set hierInfo($win-selected) ""
    set hierInfo($win-command) $cmd

    set counter 0
    while {1} {
        set var "hierData#[incr counter]"
        upvar #0 $var data
        if {![info exists data]} {
            break
        }
    }
    set hierInfo($win-data) $var
    set data(root-label) ""
    set data(root-children) ""

    frame $win -class Hierlist
    scrollbar $win.sbar -command "$win.hbox yview"
    pack $win.sbar -side right -fill y
    text $win.hbox -wrap none -takefocus 0 \
        -yscrollcommand "$win.sbar set"
    pack $win.hbox -side left -expand yes -fill both

    set tabsize [option get $win indent Indent]
    set tabsize [winfo pixels $win $tabsize]
    set tabs "15"
    for {set i 1} {$i < 20} {incr i} {
        lappend tabs [expr $i*$tabsize+15]
    }
    $win.hbox configure -tabs $tabs

    set btags [bindtags $win.hbox]
    set i [lsearch $btags Text]
    if {$i >= 0} {
        set btags [lreplace $btags $i $i]
    }
    bindtags $win.hbox $btags

    bind $win <Destroy> "hierlist_destroy $win"
    return $win
}

proc hierlist_destroy {win} {
    global hierInfo

    if {[info exists hierInfo($win-data)]} {
        set var $hierInfo($win-data)
        upvar #0 $var data
        if {[array exists data]} {unset data}
        if {[array exists hierInfo($win-data)]} {unset hierInfo($win-data)}
	  if {[array exists v]} {unset v}
	  if {[array exists h]} {unset h}
	  if {[array exists c]} {unset c}
	  if {[array exists tallennettu]} {unset tallennettu}
    }
}

proc hierlist_display {win info} {

    hierlist_data $win $info
    hierlist_redraw $win eventually
}

proc hierlist_redraw {win {when "now"}} {
    global hierInfo

    if {$when == "eventually"} {
        if {$hierInfo($win-pending) == ""} {
            set hierInfo($win-pending) [after idle [list hierlist_redraw $win]]
        }
        return
    }
    set hierInfo($win-pending) ""
    set hierInfo($win-selected) ""

    $win.hbox delete 1.0 end
    $win.hbox mark set "root:start" 1.0
    $win.hbox mark gravity "root:start" left
    hierlist_insert $win "root"
}

proc hierlist_insert {win node} {
    global hierInfo
    global paikka	

    set var $hierInfo($win-data)
    upvar #0 $var data

    set indent ""
    foreach digit [split $node "-"] {
        append indent "\t"
    }

    $win.hbox mark set pos "$node:start"

    set nodes $data($node-children) 

    foreach subnode $nodes {
        if {$data($subnode-children) != ""} {
            set arrow "$win.hbox.arrow-$subnode"
            label $arrow -image $hierInfo(sideArrow) \
                -borderwidth 0
            bind $arrow <ButtonPress-1> \
                "hierlist_expand $win $subnode"
            $win.hbox window create pos -window $arrow
        }
        $win.hbox insert pos \
            "$indent$data($subnode-label)\n" $subnode

	  set paikka $subnode
        $win.hbox tag bind $subnode <ButtonPress-1> \
		"valitseSolmu $win $subnode" 

        $win.hbox tag bind $subnode <Double-Button-1> \
		"avaaTaiLisaaVaatimus $paikka \"$data($subnode-label)\"" 

        $win.hbox tag configure $subnode -background ""
        $win.hbox mark set "$subnode:start" pos
        $win.hbox mark gravity "$subnode:start" left
    }
    $win.hbox mark set "$node:end" pos
}

proc hierlist_expand {win node} {
    global hierInfo

    set arrow "$win.hbox.arrow-$node"
    set image [$arrow cget -image]

    if {$image == $hierInfo(sideArrow)} {
        $arrow configure -image $hierInfo(downArrow)
        bind $arrow <ButtonPress-1> \
            "hierlist_collapse $win $node"

        hierlist_insert $win $node
    }
}

proc hierlist_collapse {win node} {
    global hierInfo

    set arrow "$win.hbox.arrow-$node"
    set image [$arrow cget -image]

    if {$image == $hierInfo(downArrow)} {
        $arrow configure -image $hierInfo(sideArrow)
        bind $arrow <ButtonPress-1> \
            "hierlist_expand $win $node"

        $win.hbox delete "$node:start" "$node:end"
    }
}

proc hierlist_expand_all {win {node ""} {recurs ""}} {
    global hierInfo

    upvar #0 $hierInfo($win-data) data
    if {$node == ""} {
        set node "root"
        set recurs "all"
    }

    foreach subnode $data($node-children) {
        if {[llength $data($subnode-children)] > 0} {
            hierlist_expand $win $subnode
        }
        if {$recurs == "all"} {
            hierlist_expand_all $win $subnode $recurs
        }
    }
}

proc hierlist_select {win node} {
    	global hierInfo

	set var $hierInfo($win-data) 	
      upvar #0 $var data
    	if {$hierInfo($win-selected) != ""} {
        $win.hbox tag configure $hierInfo($win-selected) -background ""
    	}

	set onOtsikko [onkoOtsikko $data($node-label)] 	
	set onAlinOtsikko [onkoAlinOtsikko $win $node]  
	if {$onOtsikko && !$onAlinOtsikko} {
		set activebg [option get $win activeColor Color]
	} elseif {$onAlinOtsikko} { 				
		set activebg [option get $win activeAlinOtColor Color]
	} else {
		set activebg [option get $win activeVaColor Color]
	} 								
    	$win.hbox tag configure $node -background $activebg
    	set hierInfo($win-selected) $node
    	if {$hierInfo($win-command) != ""} {
        	uplevel #0 $hierInfo($win-command) $node
    	}
}

proc hierlist_data {win info} {
    global hierInfo

    set var $hierInfo($win-data)
    upvar #0 $var data
    if {[array exists data]} {unset data}
    hierlist_data_add $var root "" $info
}

proc hierlist_data_add {var node label info} {
    upvar #0 $var data

    set data($node-label) $label
    set data($node-children) ""
    set num 0
    foreach rec $info {
	set subnode "$node-[incr num]"
	lappend data($node-children) $subnode
	set sublabel [lindex $rec 0]
      set subinfo [lindex $rec 1]

	set onOtsikko [onkoOtsikko $sublabel]
	if {! $onOtsikko} {	
		tallennaVaatimuksenSolmu $sublabel $subnode 
      }
	hierlist_data_add $var $subnode $sublabel $subinfo
    }
}

proc hierlist_data_cmp {var node1 node2} {
    upvar #0 $var data
    return [string compare $data($node1-label) $data($node2-label)]
}

proc hierlist_add {win path} {
    global hierInfo

    set var $hierInfo($win-data)
    upvar #0 $var data

    set node "root"
    foreach name $path {
        set found 0
        set num 0
        foreach subnode $data($node-children) {
            incr num
            if {$data($subnode-label) == $name} {
                set found 1
                break
            }
        }
        if {!$found} {
            set subnode "$node-$num"
            set data($subnode-label) $name
            set data($subnode-children) ""
            lappend data($node-children) $subnode
        }
        set node $subnode
    }
    hierlist_redraw $win eventually
    return $node
}

proc hierlist_selected {win} {
    global hierInfo
    return $hierInfo($win-selected)
}

proc hierlist_node {win path node} {
    global hierInfo
    set var $hierInfo($win-data)
    upvar #0 $var data
    foreach name $path {
        set found 0
        set num 0
        foreach subnode $data($node-children) {
            incr num
	  	set data($subnode-label) \
		     	$data($subnode-label)
            if {$data($subnode-label) == $name} {
			set found 1
			set node $subnode
			return $node
            } else {
            	set isanode $subnode
			set node $subnode
			set haettunode [hierlist_node $win $path $node]
			if {$haettunode != ""} {
            		return $haettunode
        		}
			set subnode $isanode
            }
        }
        if {!$found} {
            return ""
        } 
        set node $subnode
    }
    return $haettunode
}

proc annaAika {} {
	return [clock format [clock seconds] -format "%d.%m.%Y %H.%M"]
}

proc asetaKayttaja {} {
	global m tcl_platform tcl_version env

	if {[info exists env(USER)]} {
		set m(kayttaja) $env(USER)
	} elseif {[info tclversion] >= 8.3} {	
		set m(kayttaja) $tcl_platform(user)	
	} else {
		set m(kayttaja) "unknown"
	}
}

proc asetaOletus {sovellus} {
	global k m tallennettu

	set ai .asetuksetIkkuna
	set otsikko "$k(asetukset)"
	set labeltext "$k(anna$sovellus)" 
	set vanhaasetus $m($sovellus)
	if {[winfo exists $ai]} {
		wm deiconify $ai
	     	raise $ai
   	} else {
	     	toplevel $ai -class "Asetuksetikkuna"
		wm title $ai "$otsikko - $k($sovellus)"
		wm protocol $ai WM_DELETE_WINDOW "suljeAi $ai $sovellus"

		frame $ai.fb -borderwidth 2 -height 16 
		pack $ai.fb -side bottom -anchor e -fill x
		button $ai.fb.tallenna -text "$k(tallenna)" -width 8 \
			-command "tallennaAsetuksetTiedostoon $ai $sovellus" 
		button $ai.fb.sulje -text "$k(sulje)" -width 8 \
			-command "suljeAi $ai $sovellus"
		pack $ai.fb.sulje -side right -padx 5 -pady 3
		pack $ai.fb.tallenna -side right -padx 5 -pady 3
		frame $ai.f -borderwidth 2 -relief ridge -height 30 -width 70
		pack $ai.f -side top -anchor e -expand yes -fill both
		label $ai.f.l -text "$labeltext" -justify left
		pack $ai.f.l -side top -anchor nw -padx 5 
		entry $ai.f.e -bg white -width 50 -relief sunken
		button $ai.f.b -text "$k(selaa)..." \
			-width 12 -justify left -command "selaaOletus $ai $sovellus"
		pack $ai.f.b -side right -padx 5 -pady 5
		pack $ai.f.e -side right -padx 5 -expand yes -fill x
		$ai.f.e delete 0 end
		$ai.f.e insert end $vanhaasetus
		set tallennettu(asetukset) 0
		focus $ai.f.e
		grab $ai
	}
}

proc selaaOletus {ai sovellus} {
	global k 

	set otsikko "$k(valitse) $k($sovellus)"
	set uusiasetus [tk_getOpenFile -title "$otsikko"]
	if {$uusiasetus != ""} {
		$ai.f.e delete 0 end
		$ai.f.e insert end $uusiasetus
		wm deiconify $ai
		focus $ai.f.e
	}
}

 proc avaaJarjestysIkkuna {idTunnus toimenpide} {
	global avattuVM
	global v alasolmut ji k solmu suorita idTun edvalinta valittu

	set ji .jarjestys
 	set solmu "$v($idTunnus,paikka)"
	set lista $alasolmut($solmu)
	set idTun $idTunnus
	set otsikko "$k(muutajarjestysta)"	
	set huomautus1 "$k(vaatimusmaarittelyaeioleavattu)"
	set huomautus2 "$k(otsikonallaonvainyksivaatimus)"

	switch $toimenpide {
		"jarjesta" {
			set ikkunanotsikko "$k(vaatimustenjarjestyksenmuuttaminen)"
			set suorita "muutaJarjestys"
			set teksti1 "$k(valitsepaikka) \n\"$v($idTunnus,nimi)\""
		}				
		"siirra" {
			set ikkunanotsikko "$k(vaatimuksensijainninmuuttaminen)"
			set suorita "siirraJarjestys"
			set teksti1 "$k(valitseotsikko) \n\"$v($idTunnus,nimi)\""
		}	
	}

	if {$avattuVM == 1} {
		if {[winfo exists $ji]} {
			wm deiconify $ji
		     	raise $ji
   		} else {
		  if {[llength $lista] == 1 && $toimenpide == "jarjesta"} {
			after idle {.dialog_mj2.msg configure -wraplength 10c}
			set vastaus [tk_dialog .dialog_mj2 $otsikko $huomautus2 info 0 OK]
		   } else {
	     		toplevel $ji -class "Jarjestysikkuna"
			wm title $ji "$ikkunanotsikko"
	
			wm protocol $ji WM_DELETE_WINDOW "suljeXiIkkuna $ji"

			set f $ji.fb
			frame $f -borderwidth 2 -height 16 
			pack $f -side bottom -anchor e -fill x
			button $f.siirra -text "$k(siirra)" -width 8 -state disabled \
				-command {$suorita $solmu $idTun $valittu} 
			button $f.sulje -text "$k(peruuta)" -width 8 \
				-command "suljeXiIkkuna $ji"
			pack $f.sulje $f.siirra -side right -padx 5 -pady 3

			set f $ji.fv 
			frame $f -borderwidth 2 -relief ridge -height 30 -width 70
			pack $f -side top -anchor e -expand yes -fill both

			set fk $f.k 
			frame $fk -borderwidth 2
			pack $fk -side left -expand 1 -fill both
		 	label $fk.lbKVa -text $teksti1 -justify left 
			pack $fk.lbKVa -side top -padx 5    
			scrollbar $fk.scroll -command "$fk.t yview"
			text $fk.t -bg white -yscroll "$fk.scroll set" \
				-setgrid 1 -height 8 -width 50
			pack $fk.scroll -side right -fill y
			pack $fk.t -side top -expand 1 -fill both

			set tbox $ji.fv.k.t
			$tbox delete 1.0 end
			set y "$k(viimeiseksi)"
			set edvalinta 0
			switch $toimenpide {
				"jarjesta" {
					foreach i $lista {
						lappend apulista "$v($i,nimi)" 
					}
					lappend apulista $y
					tulostaListaJIkkunaan $tbox $apulista $suorita $toimenpide
				}				
				"siirra" {
					set apu [lueHierarkiaListaan]
					set apulista ""
					foreach rivi $apu {
						set onOtsikko [onkoOtsikko $rivi]
						if {$onOtsikko} {
							lappend apulista $rivi
						}
					}
					tulostaListaJIkkunaan $tbox $apulista $suorita $toimenpide
				}	
			}
			focus $ji
			grab $ji
		   }	
		}
	} else {
		after idle {.dialog_mj1.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_mj1 $otsikko $huomautus1 info 0 OK]
	}
}

proc lopeta {} {
	global tallennettu avattuVM

	if {$avattuVM} {
		suljeHi exit
		if {$tallennettu(tiedostoon)} {
			destroy .
		}
	} else {
		destroy .
	}
}

proc luoYleisetIkkuna {} {
	global v k avattuVM tallennettu

	set gi .yleisetIkkuna
	set otsikko "$k(yleistiedot)"	
	set huomautus "$k(vaatimusmaarittelyaeioleavattu)"
   if {$avattuVM} {
	if {[winfo exists $gi]} {
		wm deiconify $gi
	     	raise $gi
   	} else {
	     	toplevel $gi -class "Yleisetikkuna"
		wm title $gi $otsikko
		wm protocol $gi WM_DELETE_WINDOW "suljeGi $gi"

		set f $gi.fb
		frame $f -borderwidth 2 -height 16 
		pack $f -side bottom -anchor e -fill x
		button $f.tallenna -text "$k(tallenna)" -width 8 \
			-command {tallennaYleisetTiedostoon} 
		button $f.sulje -text "$k(sulje)" -width 8 \
			-command "suljeGi $gi"

		button $f.muokkaa -text "$k(avaaeditoriin)" \
			-width 12 -justify left -command "after idle {avaaEditoriin yleistiedot}"
		pack $f.muokkaa -side left -padx 5 -pady 3

		pack $f.sulje -side right -padx 5 -pady 3
		pack $f.tallenna -side right -padx 5 -pady 3

		set f $gi.f 
		frame $f -borderwidth 2 -relief ridge -height 30 -width 70
		pack $f -side top -anchor e -expand yes -fill both

		text $f.txt -bg white -width 47 -wrap word -height 10 \
		-yscrollcommand "$f.vscroll set"
		scrollbar $f.vscroll -command "$f.txt yview"
		pack $f.vscroll -side right -fill y -padx 1
		pack $f.txt -side right -expand yes -fill both

		$f.txt delete 1.0 end
		set laskuri 0
		foreach rivi $v(r,yleista) {
			$f.txt insert end "$rivi\n"
			incr laskuri
		}
		$f.txt delete {end - 1 chars} end

		set tallennettu(yleiset) 0
		raise $gi
		focus $gi
		grab $gi
	}
   } else {
		after idle {.dialog_lyi.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_lyi $otsikko $huomautus info 0 OK]
   }
}

proc naytaTietoja {} {
   	global k m

	set otsikko $k(tietoja)
	set huomautus "sfrm v$m(sfrm-versio)\n($m(luontipvm))\n\n$k(idea): \
		$m(sfrm-idea)\n$k(toteutus): $m(sfrm-toteutus)\n\n(c) \
		2001 - 2002 $k(joy)\n$k(tkt)"
	tk_dialog .dialog_nt $otsikko $huomautus info 0 OK
}

proc ohjeAvaa {} {
	global k m

	set browser $m(selain)
      set suodatin {
	   {{HTML-files} {.htm .html}}
 	   {{All files} {*}}	 				
   	}
	set polku [pwd]
	set tiedosto $polku/ohje/sfrmhelp.html
	if {![file isfile $tiedosto]} {
	 	set tiedosto [tk_getOpenFile -title "$k(avaaohje)" -filetypes $suodatin \
			-initialfile "sfrmhelp.html" -initialdir ./ohje] 
	} 
      if {$tiedosto != ""} {
		if {$browser == ""} {
			set otsikko $k(lataaoletukset) 
			set huomautus $k(oletusselaintaeiole)
			tk_dialog .dialog_ra $otsikko $huomautus info 0 OK
		} else {
			set path [file dirname $tiedosto]
			set file [file tail $tiedosto]
			if {[catch {exec $browser "$tiedosto" &} errmsg]} {
				set otsikko $k(avaaohje) 
				set huomautus "$k(virheavattaessaohjetta) $errmsg"
				tk_dialog .dialog_avm1 $otsikko $huomautus info 0 OK
			} 
		}
	}	
}

proc onkoKaikkiVaatimuksetTallennettu {} {
	global idTun v tallennettu vaatimukset

	set tallentamaton ""
	if {[llength $vaatimukset] != 0} {
		foreach i $vaatimukset {
			set vi .vaatimus-$i
			set idTun $i
		   	if {[winfo exists $vi]} {
			   	if {$tallennettu($vi)} {
					tarkistaVaatimuksenMuutokset $i
				}
				if {!$tallennettu($vi)} {
					lappend tallentamaton "$i"
				}
			}
		}
	}
	return $tallentamaton
}

proc onkoYleisetMuuttunut {} {
	global v tallennettu 

	set f .yleisetIkkuna.f.txt
	$f mark set last end
	set palautettava 0
	set tallennettu(yleiset) 1
	set jatketaan 1
	set i 1
	set apu ""
	while {$jatketaan != 0} {
		if {[$f compare $i.end < last] == 1} {
			set rivi [$f get $i.0 $i.end]
			lappend apu "$rivi"
			incr i 
		} else {
			set jatketaan 0
		}
	}
	set uusi $apu
	set vanha $v(r,yleista)
	set muuttunut [string compare $uusi $vanha]
	if {$muuttunut != 0} {
		set palautettava $uusi
		set tallennettu(yleiset) 0
	}
	return $palautettava
}

proc paivitaPaaikkunanOtsikko {} {
	global m

	if {$m(tiedosto) == ""} {
		wm title . "Sfrm v$m(sfrm-versio)"
	} else {
		wm title . "$m(tyonimi).rmd - Sfrm v$m(sfrm-versio)"
	}
}

proc suljeAi {ai sovellus} {
	global k
 
	set otsikko 	"$k(sulje) $k(asetukset)"	
	set huomautus 	"$k(tietojaeioletallennettu)"
	set onMuuttunut 	[onkoAsetuksetMuuttunut $ai $sovellus]

	if {$onMuuttunut != 0} {
		wm deiconify $ai
		focus $ai
		set vastaus [tk_dialog .dialog_sai $otsikko \
		$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	tallennaAsetuksetTiedostoon $ai $sovellus 
				suljeXiIkkuna $ai}
			1 {	suljeXiIkkuna $ai}
    			2 {	wm deiconify $ai
				focus $ai}
		}
	} else {
		suljeXiIkkuna $ai	
	}
}

proc suljeHi {menuvalinta} {
	global k tallennettu avattuVM

	set otsikko "$k(vaatimusmaarittelynsulkeminen)"	
	set huomautus "$k(haluatkotallentaavaatimuksettiedostoon)"
   if {$avattuVM} {
	set tallentamaton [onkoKaikkiVaatimuksetTallennettu]
	if {!$tallennettu(tiedostoon)} {
		after idle {.dialog_sh.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_sh $otsikko \
		$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	
				tallennetaankoTiedostoon $menuvalinta
				set tallentamaton [onkoKaikkiVaatimuksetTallennettu]
				foreach j $tallentamaton {
					destroy .vaatimus-$j
				}
				suljeVM
			}
			1 {	foreach j $tallentamaton {
					destroy .vaatimus-$j
				}
				suljeVM
			}
    			2 {	wm deiconify .
				focus .
			}
		}
	} else {
		suljeVM
	}
   }
}

proc suljeGi {gi} {
	global k
 
	set otsikko 	"$k(yleistiedotikkunansulkeminen)"	
	set huomautus 	"$k(tietojaeioletallennettu)"
	set onMuuttunut [onkoYleisetMuuttunut]
	if {$onMuuttunut != 0} {
		wm deiconify $gi
		focus $gi
		after idle {.dialog_sgi.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_sgi $otsikko \
		$huomautus question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch -- $vastaus {
    			0 {	tallennaYleisetTiedostoon 
				suljeXiIkkuna $gi}
			1 {	suljeXiIkkuna $gi}
    			2 {	wm deiconify $gi
				focus $gi}
		}
	} else {
		suljeXiIkkuna $gi	
	}
}

proc suljeVM {} {
	global idTun v m tallennettu avattuVM vaatimukset ehto alasolmut

	foreach i $vaatimukset {
		set vi .vaatimus-$i
		set idTun $i
	   	if {[winfo exists $vi]} {
			suljeVi $vi .
			destroy $vi
		}
	}
	set m(tiedosto) ""
	paivitaPaaikkunanOtsikko
	hierlist_destroy .list
	.list.hbox delete 1.0 end
	set tallennettu(tiedostoon) 1
	set avattuVM 0
	set vaatimukset ""
	if {[winfo exists .raportti]} {destroy .raportti}
  	if {[array exists ehto]} {unset ehto}
	if {[array exists alasolmut]} {unset alasolmut}
}

proc suljeXiIkkuna {i} {
 	destroy $i
	raise .
	wm deiconify . 
	focus .
}

proc tallennetaankoTiedostoon {menuvalinta} {
	global idTun k tallennettu avattuVM 

	set otsikko "$k(tallennatiedostoon)" 
	set huomautus "$k(tallennustaeisuoritettu)" 
	if {$avattuVM == 0} {
		tk_dialog .dialog_tvt1 $otsikko $huomautus info 0 OK
	} else {
	   set huomautus1 "$k(kaikkiaavoimiaeioletallennettu)"
	   set huomautus2 "$k(valitsetallentamisenjalkeentallennauudelleen)"
	   set huomautus3 "$k(valitsetallentamisenjalkeensuljeuudelleen)"
	   set huomautus4 "$k(valitsetallentamisenjalkeenlopetauudelleen)"
	   set tallentamaton [onkoKaikkiVaatimuksetTallennettu]
	   set kaikkiTallennettu [llength $tallentamaton]

	   if {$kaikkiTallennettu != 0} {
		after idle {.dialog_tt1.msg configure -wraplength 10c}
		set vastaus [tk_dialog .dialog_tt1 $otsikko \
		   $huomautus1 question 0 $k(kylla) $k(ei) $k(peruuta)]
		switch $vastaus {
    			0 {	foreach j $tallentamaton {
					set vi .vaatimus-$j
					set idTun $j
					tallennaVaatimus $vi 
					if {!$tallennettu($vi)} { 
					  switch $menuvalinta {
					    "tallenna" { 
						after idle {.dialog_tt2.msg configure -wraplength 10c}
						set vastaus [tk_dialog .dialog_tt2 $otsikko \
						   $huomautus2 info 0 OK]
					    }
					    "sulje" {	
						after idle {.dialog_tt3.msg configure -wraplength 10c}
						set vastaus [tk_dialog .dialog_tt3 $otsikko \
						   $huomautus3 info 0 OK]
					    }
					    "exit" {	
						after idle {.dialog_tt4.msg configure -wraplength 10c}
						set vastaus [tk_dialog .dialog_tt4 $otsikko \
						   $huomautus4 info 0 OK]
					    }
				   	  }
					  wm deiconify $vi 			
					  focus $vi.frKanvaasi.ca.frPo.frNi.enNi
					  tkwait variable $vi.frKanvaasi.ca.frPo.frNi.enNi
					} 
				}
				tallennaVaatimuksetTiedostoon 
			}
			1 {	tallennaVaatimuksetTiedostoon}
    			2 {	wm deiconify .
				focus .}
		}
	   } else {
	  	tallennaVaatimuksetTiedostoon
	   }
	}
}

proc vaihdaKohdistin {tyyppi} {
	if {[winfo exists .list.hbox]} {	
		if {$tyyppi == "oletus"} {
			set tyyppi [option get .list.hbox cursor cursor]
		}
   		.list.hbox configure -cursor $tyyppi
	   	.list configure -cursor $tyyppi
		foreach vi [winfo children .] {
			$vi configure -cursor $tyyppi 
		}			
	}
} 

proc avaaVM {} {
   	global c h k v m
	global vmTiedosto
	global tallennettu vaatimukset
	global virhe virhelaskuri avattuVM

	if {[array exists v]} {
		suljeHi sulje
	} 
	if {!$avattuVM} {
		set otsikko "$k(avaavm)"	
		set virhe 0
		set tiedosto ""

	      set suodatin {
      	   {{Sfrm-hierarchy files} {.rmh}}
		   {{Text files} {.txt}}
 		   {{All files} {*}}	 				
	      }
      	set m(tiedosto) [tk_getOpenFile -title "$k(avaatiedosto)" -filetypes $suodatin]
		vaihdaKohdistin watch
		if {$m(tiedosto) != ""} {
			if {[catch {lueHierarkia $m(tiedosto)} errmsg] || $virhe} {
				set huomautus1 "$m(tiedosto), line: $virhelaskuri - $k(avaavmhuomautus1) $errmsg"
				tk_dialog .dialog_avm1 $otsikko $huomautus1 info 0 OK
			} else {
				hierlist_display .list [lueHierarkiaTaulukko]
				set vmTiedosto [file rootname $m(tiedosto)]
				set m(tyonimi) [file tail [file rootname $m(tiedosto)]]
				set oletusasetustiedosto [file join $m(sfrm-dir) $m(kayttaja).rms]
				if {[catch {lataaVaatimusNumerot $oletusasetustiedosto} errmsg] || $virhe} {
					set otsikko $k(lataaoletukset)
					set huomautus "$oletusasetustiedosto, line: $virhelaskuri - $k(lataaoletuksethuomautus)"
					tk_dialog .dialog_avm $otsikko $huomautus info 0 OK
				}
				set luokitusTiedosto $vmTiedosto.rmc 
				if {[file exists $luokitusTiedosto]} {
					if {[array exists c]} {unset c} 
					if {[catch {lueVaatimusluokat $luokitusTiedosto} errmsg] || $virhe} {
						set huomautus2 "$luokitusTiedosto, line: $virhelaskuri - $k(avaavmhuomautus2)"
						tk_dialog .dialog_avm2 $otsikko $huomautus2 info 0 OK
					}
				} else {
					set huomautus3 "$luokitusTiedosto - $k(avaavmhuomautus3)"
					tk_dialog .dialog_avm3 $otsikko $huomautus3 info 0 OK
				}
				set vaatimukset ""	
				set vaatimusTiedosto $vmTiedosto.rmd 
				if {[file exists $vaatimusTiedosto]} {
					if {[catch {lueVaatimustiedot $vaatimusTiedosto} errmsg] || $virhe} {
						set huomautus4 "$vaatimusTiedosto - $k(avaavmhuomautus4)"
						tk_dialog .dialog_avm4 $otsikko $huomautus4 info 0 OK
					} else {
						haeVaatimuksetListaan .list
						paivitaPaaikkunanOtsikko
					}
				} else {
					set huomautus5 "$vaatimusTiedosto - $k(avaavmhuomautus5)"
					tk_dialog .dialog_avm5 $otsikko $huomautus5 info 0 OK
				}
				set yleisetTiedosto $vmTiedosto.rmg 
				if {[file exists $yleisetTiedosto]} {
					if {[catch {lueYleisetTiedot $yleisetTiedosto} errmsg] || $virhe} {
						set huomautus6 "$yleisetTiedosto - $k(avaavmhuomautus6)"
						tk_dialog .dialog_avm6 $otsikko $huomautus6 info 0 OK
					}
				} else {
					set otsikko "$k(avaavm)"
					set huomautus7 "$yleisetTiedosto - $k(avaavmhuomautus7)"
					tk_dialog .dialog_avm7 $otsikko $huomautus7 info 0 OK
					set v(r,yleista) ""
				}	
				set avattuVM 1
				set tallennettu(yleiset) 1
				set tallennettu(tiedostoon) 1
				update
				wm deiconify .
				hierlist_expand_all .list
			}
		set virhe 0
		}
	}
	vaihdaKohdistin oletus
}

proc luoKayttoliittyma {} {
   	global k m

	wm title . "Sfrm v$m(sfrm-versio)"
	wm geometry  . "350x600"
	global idTun
	global paikka
	global tallennettu
	global avattuVM

	set menustatus ""
	frame .statusBar 
	label .statusBar.label -textvariable menustatus -relief sunken -bd 1 -anchor w
	pack .statusBar.label -side left -padx 1 -expand yes -fill both
	pack .statusBar -side bottom -fill x -pady 1

	menu .menu -tearoff 0
	set mnu .menu.tiedosto
	menu $mnu -tearoff 1 
	.menu add cascade -label "$k(tiedosto)" -underline 0  -menu $mnu  
	$mnu add command -label "$k(avaa)..." -underline 0 -command "avaaVM"
	$mnu add command -label "$k(tallenna)" -underline 0 \
		-command {tallennetaankoTiedostoon tallenna}
	$mnu add sep
	$mnu add cascade -label "$k(raportti)"  -menu .menu.tiedosto.raportti -underline 0
	$mnu add sep
	$mnu add command -label "$k(sulje)" -underline 0 \
		-command {suljeHi sulje}
	$mnu add command -label "$k(lopeta)" -underline 0 -command "lopeta"

	set mnu .menu.vaatimus
	menu $mnu -tearoff 1 
	.menu add cascade -label "$k(vaatimus)" -menu $mnu -underline 0
	$mnu add command -label "$k(lisaa)" -underline 0 \
		-command {tarkistaValintaJaLisaa}
	$mnu add command -label "$k(muokkaa)" -underline 0 \
		-command {tarkistaValintaJaAvaa} 
	$mnu add command -label "$k(muutajarjestysta)" -underline 1 \
		-command {tarkistaValintaJaJarjesta jarjesta} 
	$mnu add command -label "$k(muutasijaintia)" -underline 3 \
		-command {tarkistaValintaJaJarjesta siirra} 

	set mnu .menu.asetukset 
	menu $mnu -tearoff 1 
	.menu add cascade -label "$k(asetukset)" -menu $mnu -underline 0
	$mnu add command -label "$k(oletuseditori)" -underline 0 \
		-command {asetaOletus "editori"}
	$mnu add command -label "$k(oletusselain)" -underline 1 \
		-command {asetaOletus "selain"}
	$mnu add sep
	$mnu add cascade -label "$k(kieli)" -menu .menu.asetukset.kieli -underline 0

	set mnu .menu.yleistiedot 
	menu $mnu -tearoff 1 
	.menu add cascade -label "$k(yleistiedot)" -menu $mnu -underline 0
	$mnu add command -label "$k(muokkaa)" -underline 0 -command {luoYleisetIkkuna}

	set mnu .menu.ohje
	menu $mnu -tearoff 1 
	.menu add cascade -label "$k(ohje)" -menu $mnu -underline 0
	$mnu add command -label "$k(ohje)" -underline 0 \
		-command "ohjeAvaa"
	$mnu add sep
	$mnu add command -label "$k(tietoja)" -underline 0 \
		-command {naytaTietoja}

	set mnu .menu.tiedosto.raportti 
	menu $mnu -tearoff 0 
	$mnu add command -label "$k(luo)" -underline 0 \
		-command {luoRaporttiIkkuna}
	$mnu add command -label "$k(avaa)" -underline 0 \
		-command {raporttiAvaa ""}
	set mnu .menu.asetukset.kieli 
	menu $mnu -tearoff 0 
	for {set i 0} {$i < [llength $k(kielet)]} {incr i} {
      	$mnu add radio -label [lindex $k(kielet) $i] -variable m(kieli) \
		   -value $i -command "vaihdaKieli $i"
	}
	$mnu invoke $m(kieli)
	. configure -menu .menu

	hierlist_create .list
	pack .list -side bottom -expand yes -fill both
	set avattuVM 0 
	update
	wm deiconify .

	bind Menu <<MenuSelect>> {
	    global $menustatus
	    if {[catch {%W entrycget active -label} label]} {
		set label ""
	    }
	    set menustatus $label
	    update idletasks
	}
}

proc asetaAlkuasetukset {} {
	global env k m
	global tcl_platform

   	set m(editori) ""	
   	set m(kayttaja) ""
   	set m(kieli) 0
   	set k(kielet) {Suomi English}
   	set m(alkunumero) ""
   	set m(loppunumero) ""
   	set m(luontipvm) "23.5.2002"
   	set m(platform) $tcl_platform(platform)
   	set m(selain) ""
   	set m(sfrm-toteutus) "Jussi Khknen"
   	set m(sfrm-idea) "Jorma Sajaniemi"
   	set m(sfrm-versio) 1.0
	set m(sfrm-dir) ""
	set m(sfrm-nuolet) ""
   	set m(tiedosto) ""
   	set m(tyonimi) ""
}

wm protocol . WM_DELETE_WINDOW lopeta
asetaAlkuasetukset
asetaTekstit
lataaKielitiedot $m(kieli)
luoKayttoliittyma
asetaKayttaja
set oletusasetustiedosto "$m(kayttaja).rms" 
if {[file exists $oletusasetustiedosto] == 0} {
	set nimi [info script] 
	set m(sfrm-dir) [file dirname $nimi] 
	set oletusasetustiedosto [file join $m(sfrm-dir) $m(kayttaja).rms] 
}
if {[catch {lataaOletusasetukset $oletusasetustiedosto} errmsg] || $virhe} {
	set otsikko $k(lataaoletukset)
	set huomautus "$oletusasetustiedosto, line: $virhelaskuri - $k(lataaoletuksethuomautus)"
	tk_dialog .dialog_avm1 $otsikko $huomautus info 0 OK
}
if {$m(sfrm-nuolet) != ""} {
 	set hierInfo(sideArrow) [image create photo \
    		-file [file join $m(sfrm-nuolet) side.gif]]
 	set hierInfo(downArrow) [image create photo \
    		-file [file join $m(sfrm-nuolet) down.gif]]
} else {
	set hierInfo(sideArrow) [image create photo -file side.gif]
	set hierInfo(downArrow) [image create photo -file down.gif]
}
